%let cty = ARG BGR BLZ CAN COL CYP CZE DEU ENG FRA
           GRC HKG HUN IRN ISL ISR ITA KWT LTU LVA
           MAR MDA MKD NLD NOR NZL ROM RUS SCO SGP
           SVK SVN SWE TUR USA SE3;

Options nosource nocenter;

LIBNAME libdat  "c:\pirls\Data" ;
LIBNAME library "c:\pirls\Data" ;

%macro doit;
  %let i = 1;
     %do %while(%length(%scan(&cty,&i)));
       %let ccode = %lowcase(%scan(&cty,&i));

%let fname= acg&ccode.r1 ;

FILENAME rawinp "c:\pirls\Data\&fname..dat" ;

%PUT INFO: data set definition ;
%PUT INFO: data set definitions may need to be modified ;

*Output data set ;
data libdat.&fname;

*NOTE: LRECL may need to be modified ;
INFILE rawinp LRECL=1250 END=eof LENGTH=lnline LINE=ln MISSOVER ;

%PUT INFO: shorten variable definitions to save secondary storage area ;
%PUT INFO: refer to the SAS manual for an appropriate length for variables ;

*NOTE: The LENGTH statement in a data step specifies the number of bytes, the
       SAS - sytem uses for storing values of variables in each data set being created. ;
LENGTH DEFAULT=5 ;
LENGTH      IDCNTRY    5 ;
LENGTH      IDSCHOOL   4 ;
LENGTH      IDPOP      3 ;
LENGTH      INPRL01    3 ;
LENGTH      ACBGGRD1   3 ;
LENGTH      ACBGGRD2   3 ;
LENGTH      ACBGGRD3   3 ;
LENGTH      ACBGGRD4   3 ;
LENGTH      ACBGGRD5   3 ;
LENGTH      ACBGGRD6   3 ;
LENGTH      ACBGGENR   4 ;
LENGTH      ACBGBENR   4 ;
LENGTH      ACBGG4EN   3 ;
LENGTH      ACBGB4EN   3 ;
LENGTH      ACBGCLOC   3 ;
LENGTH      ACBGCLOS   3 ;
LENGTH      ACBGCOMM   3 ;
LENGTH      ACBGAVR1   3 ;
LENGTH      ACBGAVR2   3 ;
LENGTH      ACBGAVR3   3 ;
LENGTH      ACBGAVR4   3 ;
LENGTH      ACBGAVR5   3 ;
LENGTH      ACBGAVR6   3 ;
LENGTH      ACBGENDY   3 ;
LENGTH      ACBGPSS1   3 ;
LENGTH      ACBGPSS2   3 ;
LENGTH      ACBGPSS3   3 ;
LENGTH      ACBGPSS4   3 ;
LENGTH      ACBGPGS1   3 ;
LENGTH      ACBGPGS2   3 ;
LENGTH      ACBGPGS3   3 ;
LENGTH      ACBGPGS4   3 ;
LENGTH      ACBGSABI   3 ;
LENGTH      ACBGIDY    3 ;
LENGTH      ACBGIHD    3 ;
LENGTH      ACBGIMD    3 ;
LENGTH      ACBGIDYW   3 ;
LENGTH      ACBGIDYO   8 ;
LENGTH      ACBGSTST   3 ;
LENGTH      ACBGINF1   3 ;
LENGTH      ACBGINF2   3 ;
LENGTH      ACBGINF3   3 ;
LENGTH      ACBGINF4   3 ;
LENGTH      ACBGINF5   3 ;
LENGTH      ACBG1GR1   3 ;
LENGTH      ACBG1GR2   3 ;
LENGTH      ACBG1GR3   3 ;
LENGTH      ACBG1GR4   3 ;
LENGTH      ACBG1GR5   3 ;
LENGTH      ACBGCUR1   3 ;
LENGTH      ACBGCUR2   3 ;
LENGTH      ACBGCUR3   3 ;
LENGTH      ACBGRWS    3 ;
LENGTH      ACBGRII    3 ;
LENGTH      ACBGRSP    3 ;
LENGTH      ACBGPOL    3 ;
LENGTH      ACBGMA1    3 ;
LENGTH      ACBGMA2    3 ;
LENGTH      ACBGMA3    3 ;
LENGTH      ACBGMA4    3 ;
LENGTH      ACBGMA5    3 ;
LENGTH      ACBGME1    3 ;
LENGTH      ACBGME2    3 ;
LENGTH      ACBGME3    3 ;
LENGTH      ACBGME4    3 ;
LENGTH      ACBGME5    3 ;
LENGTH      ACBGME6    3 ;
LENGTH      ACBGME7    3 ;
LENGTH      ACBGME8    3 ;
LENGTH      ACBGME9    3 ;
LENGTH      ACBGME10   3 ;
LENGTH      ACBGME11   3 ;
LENGTH      ACBGME12   3 ;
LENGTH      ACBGIMPL   3 ;
LENGTH      ACBGLI     3 ;
LENGTH      ACBGLIST   3 ;
LENGTH      ACBGLIBC   3 ;
LENGTH      ACBGLIBM   3 ;
LENGTH      ACBGRDCR   3 ;
LENGTH      ACBGCMP1   3 ;
LENGTH      ACBGCMP2   3 ;
LENGTH      ACBGST1    3 ;
LENGTH      ACBGST2    3 ;
LENGTH      ACBGST3    3 ;
LENGTH      ACBGST4    3 ;
LENGTH      ACBGST5    3 ;
LENGTH      ACBGST6    3 ;
LENGTH      ACBGST7    3 ;
LENGTH      ACBGST8    3 ;
LENGTH      ACBGST9    3 ;
LENGTH      ACBGST10   3 ;
LENGTH      ACBGST11   3 ;
LENGTH      ACBGST12   3 ;
LENGTH      ACBGST13   3 ;
LENGTH      ACBGPRG1   3 ;
LENGTH      ACBGPRG2   3 ;
LENGTH      ACBGPRG3   3 ;
LENGTH      ACBGPRG4   3 ;
LENGTH      ACBG4FA1   3 ;
LENGTH      ACBG4FA2   3 ;
LENGTH      ACBG4FA3   3 ;
LENGTH      ACBG4FA4   3 ;
LENGTH      ACBG4FA5   3 ;
LENGTH      ACBG4FA6   3 ;
LENGTH      ACBGPAR1   3 ;
LENGTH      ACBGPAR2   3 ;
LENGTH      ACBGPAR3   3 ;
LENGTH      ACBGPAR4   3 ;
LENGTH      ACBGCHA1   3 ;
LENGTH      ACBGCHA2   3 ;
LENGTH      ACBGCHA3   3 ;
LENGTH      ACBGCHA4   3 ;
LENGTH      ACBGCHA5   3 ;
LENGTH      ACBGPB1    3 ;
LENGTH      ACBGPB2    3 ;
LENGTH      ACBGPB3    3 ;
LENGTH      ACBGPB4    3 ;
LENGTH      ACBGPB5    3 ;
LENGTH      ACBGPB6    3 ;
LENGTH      ACBGPB7    3 ;
LENGTH      ACBGPB8    3 ;
LENGTH      ACBGPB9    3 ;
LENGTH      ACBGPB10   3 ;
LENGTH      ACBGPB11   3 ;
LENGTH      ACBGPB12   3 ;
LENGTH      ACBGPB13   3 ;
LENGTH      ACBGCOOP   3 ;
LENGTH      ACBGTSTM   3 ;
LENGTH      ACBGACT1   3 ;
LENGTH      ACBGACT2   3 ;
LENGTH      ACBGACT3   3 ;
LENGTH      ACBGACT4   3 ;
LENGTH      ACBGACT5   3 ;
LENGTH      ACBGACT6   3 ;
LENGTH      ACBGCOMP   3 ;
LENGTH      ACDGACTT   3 ;
LENGTH      DPCDATE    6 ;
LENGTH      STOTWGTU   8 ;
LENGTH      JKCZONE    3 ;
LENGTH      JKCREP     3 ;
LENGTH      WGTFAC1    8 ;
LENGTH      WGTADJ1    8 ;
LENGTH      SCHWGT     8 ;
LENGTH      ACDGIHY    8 ;
LENGTH      ACDGIDYW   8 ;
LENGTH      ACDG4PAR   3 ;
LENGTH      ACDGCHA    3 ;
LENGTH      ACDGPB     3 ;
LENGTH      ACDGST     3 ;
LENGTH      ACDGCMP    3 ;
LENGTH      ACDG1GR    3 ;


%PUT INFO: Missing category A refers to "not administered" values ;
%PUT INFO: Missing category I refers to "invalid" values ;
%PUT INFO: Missing category B refers to "logically not applicable" values ;
%PUT INFO: Missing category R refers to "not reached" items ;
%PUT INFO: Missing category . refers to missing values ;
MISSING A I B R ;

*NOTE: The INPUT statement reads raw data and assigns variable names.
       The positions specified below correspond to the positions of the variables
       in the raw data file. ;

INPUT
  IDCNTRY       1-   5     
  IDSCHOOL      6-   9     
  IDPOP        10-  10     
  INPRL01      11-  11     
  ACBGGRD1     12-  12     
  ACBGGRD2     13-  13     
  ACBGGRD3     14-  14     
  ACBGGRD4     15-  15     
  ACBGGRD5     16-  16     
  ACBGGRD6     17-  17     
  ACBGGENR     18-  21     
  ACBGBENR     22-  25     
  ACBGG4EN     26-  28     
  ACBGB4EN     29-  31     
  ACBGCLOC     32-  32     
  ACBGCLOS     33-  33     
  ACBGCOMM     34-  34     
  ACBGAVR1     35-  35     
  ACBGAVR2     36-  36     
  ACBGAVR3     37-  37     
  ACBGAVR4     38-  38     
  ACBGAVR5     39-  39     
  ACBGAVR6     40-  40     
  ACBGENDY     41-  41     
  ACBGPSS1     42-  42     
  ACBGPSS2     43-  43     
  ACBGPSS3     44-  44     
  ACBGPSS4     45-  45     
  ACBGPGS1     46-  46     
  ACBGPGS2     47-  47     
  ACBGPGS3     48-  48     
  ACBGPGS4     49-  49     
  ACBGSABI     50-  50     
  ACBGIDY      51-  53     
  ACBGIHD      54-  55     
  ACBGIMD      56-  57     
  ACBGIDYW     58-  58     
  ACBGIDYO     59-  61 .1
  ACBGSTST     62-  62     
  ACBGINF1     63-  63     
  ACBGINF2     64-  64     
  ACBGINF3     65-  65     
  ACBGINF4     66-  66     
  ACBGINF5     67-  67     
  ACBG1GR1     68-  68     
  ACBG1GR2     69-  69     
  ACBG1GR3     70-  70     
  ACBG1GR4     71-  71     
  ACBG1GR5     72-  72     
  ACBGCUR1     73-  73     
  ACBGCUR2     74-  74     
  ACBGCUR3     75-  75     
  ACBGRWS      76-  76     
  ACBGRII      77-  77     
  ACBGRSP      78-  78     
  ACBGPOL      79-  79     
  ACBGMA1      80-  80     
  ACBGMA2      81-  81     
  ACBGMA3      82-  82     
  ACBGMA4      83-  83     
  ACBGMA5      84-  84     
  ACBGME1      85-  85     
  ACBGME2      86-  86     
  ACBGME3      87-  87     
  ACBGME4      88-  88     
  ACBGME5      89-  89     
  ACBGME6      90-  90     
  ACBGME7      91-  91     
  ACBGME8      92-  92     
  ACBGME9      93-  93     
  ACBGME10     94-  94     
  ACBGME11     95-  95     
  ACBGME12     96-  96     
  ACBGIMPL     97-  97     
  ACBGLI       98-  98     
  ACBGLIST     99-  99     
  ACBGLIBC    100- 101     
  ACBGLIBM    102- 102     
  ACBGRDCR    103- 103     
  ACBGCMP1    104- 106     
  ACBGCMP2    107- 107     
  ACBGST1     108- 108     
  ACBGST2     109- 109     
  ACBGST3     110- 110     
  ACBGST4     111- 111     
  ACBGST5     112- 112     
  ACBGST6     113- 113     
  ACBGST7     114- 114     
  ACBGST8     115- 115     
  ACBGST9     116- 116     
  ACBGST10    117- 117     
  ACBGST11    118- 118     
  ACBGST12    119- 119     
  ACBGST13    120- 120     
  ACBGPRG1    121- 121     
  ACBGPRG2    122- 122     
  ACBGPRG3    123- 123     
  ACBGPRG4    124- 124     
  ACBG4FA1    125- 125     
  ACBG4FA2    126- 126     
  ACBG4FA3    127- 127     
  ACBG4FA4    128- 128     
  ACBG4FA5    129- 129     
  ACBG4FA6    130- 130     
  ACBGPAR1    131- 131     
  ACBGPAR2    132- 132     
  ACBGPAR3    133- 133     
  ACBGPAR4    134- 134     
  ACBGCHA1    135- 135     
  ACBGCHA2    136- 136     
  ACBGCHA3    137- 137     
  ACBGCHA4    138- 138     
  ACBGCHA5    139- 139     
  ACBGPB1     140- 140     
  ACBGPB2     141- 141     
  ACBGPB3     142- 142     
  ACBGPB4     143- 143     
  ACBGPB5     144- 144     
  ACBGPB6     145- 145     
  ACBGPB7     146- 146     
  ACBGPB8     147- 147     
  ACBGPB9     148- 148     
  ACBGPB10    149- 149     
  ACBGPB11    150- 150     
  ACBGPB12    151- 151     
  ACBGPB13    152- 152     
  ACBGCOOP    153- 153     
  ACBGTSTM    154- 154     
  ACBGACT1    155- 157     
  ACBGACT2    158- 160     
  ACBGACT3    161- 163     
  ACBGACT4    164- 166     
  ACBGACT5    167- 169     
  ACBGACT6    170- 172     
  ACBGCOMP    173- 175     
  ACDGACTT    176- 178     
  DPCDATE     179- 184     
  STOTWGTU    185- 197 .6
  JKCZONE     198- 199     
  JKCREP      200- 200     
  WGTFAC1     201- 213 .6
  WGTADJ1     214- 226 .6
  SCHWGT      227- 239 .6
  ACDGIHY     240- 247 .3
  ACDGIDYW    248- 250 .1
  ACDG4PAR    251- 251     
  ACDGCHA     252- 252     
  ACDGPB      253- 253     
  ACDGST      254- 254     
  ACDGCMP     255- 255     
  ACDG1GR     256- 256     
;

%PUT INFO: assign labels to variables ;
LABEL
  IDCNTRY  = "*COUNTRY ID*"
  IDSCHOOL = "*SCHOOL ID*"
  IDPOP    = "POPULATION INDICATOR"
  INPRL01  = "INDICATOR VARIABLE"
  ACBGGRD1 = "GEN/GRADES IN SCH/1 GRADE BELOW"
  ACBGGRD2 = "GEN/GRADES IN SCH/2 GRADES BELOW"
  ACBGGRD3 = "GEN/GRADES IN SCH/3 GRADES BELOW"
  ACBGGRD4 = "GEN/GRADES IN SCH/4 GRADES BELOW"
  ACBGGRD5 = "GEN/GRADES IN SCH/2ND ISCED YEAR"
  ACBGGRD6 = "GEN/GRADES IN SCH/1ST ISCED YEAR"
  ACBGGENR = "GEN/TOTAL ENROLLMENT GIRLS"
  ACBGBENR = "GEN/TOTAL ENROLLMENT BOYS"
  ACBGG4EN = "GEN/TOTAL ENROLLMENT FOURTH-GRADE GIRLS"
  ACBGB4EN = "GEN/TOTAL ENROLLMENT FOURTH-GRADE BOYS"
  ACBGCLOC = "GEN/SCH LOCATION TOWN OR CITY"
  ACBGCLOS = "GEN/SCH LOCATION SIZE"
  ACBGCOMM = "GEN/CHARACTER OF SCH LOCATION AREA"
  ACBGAVR1 = "GEN/AVAILABLE RESSOURCE/PUBLIC LIBRARY"
  ACBGAVR2 = "GEN/AVAILABLE RESSOURCE/BOOKSTORE"
  ACBGAVR3 = "GEN/AVAILABLE RESSOURCE/<2ND-LEVEL SCH>"
  ACBGAVR4 = "GEN/AVAILABLE RESSOURCE/<UNI,COLLEGE>"
  ACBGAVR5 = "GEN/AVAILABLE RESSOURCE/MUSEUM"
  ACBGAVR6 = "GEN/AVAILABLE RESSOURCE/THEATRE"
  ACBGENDY = "GEN/% STD ENROLLMENT END OF SCH YEAR"
  ACBGPSS1 = "GEN/% STD IN SCH/ECON DISADVANTAGED HOME"
  ACBGPSS2 = "GEN/% STD IN SCH/ECON AFFLUENT HOME"
  ACBGPSS3 = "GEN/% STD IN SCH/BORN IN ANOTHER COUNTRY"
  ACBGPSS4 = "GEN/% STD IN SCH/INSTR IN HOME LANGUAGE"
  ACBGPGS1 = "GEN/% STD 1-4 GRADE/ANOTHER 1ST LANGUAGE"
  ACBGPGS2 = "GEN/% STD 1-4 GRADE/LEARNING DISABILITY"
  ACBGPGS3 = "GEN/% STD 1-4 GRADE/REMEDIAL RDG INSTR"
  ACBGPGS4 = "GEN/% STD 1-4 GRADE/ENRICHMENT RDG INSTR"
  ACBGSABI = "GEN/SAME ABILITY IN 4TH GRADE CLS"
  ACBGIDY  = "GEN/4TH GRADE/INSTRUCTION DAYS PER YEAR"
  ACBGIHD  = "GEN/4TH GRADE/INSTRUCTION HOURS PER DAY"
  ACBGIMD  = "GEN/4TH GRADE/INSTRUCTION MIN PER DAY"
  ACBGIDYW = "GEN/4TH GRADE/SCH DAYS PER WEEK"
  ACBGIDYO = "GEN/4TH GRADE/SCH DAYS PER WEEK/OTHERS"
  ACBGSTST = "GEN/LENGTH STD STAY WITH SAME TCH"
  ACBGINF1 = "GEN/INFLUENCE/CURRICULUM"
  ACBGINF2 = "GEN/INFLUENCE/EXAMINATIONS+ASSESSMENTS"
  ACBGINF3 = "GEN/INFLUENCE/OTHER STANDARDIZED TESTS"
  ACBGINF4 = "GEN/INFLUENCE/WISHES OF PARENTS"
  ACBGINF5 = "GEN/INFLUENCE/WISHES OF STUDENTS"
  ACBG1GR1 = "GEN/BEGIN 1ST GRD/RECOGNIZE MOST LETTERS"
  ACBG1GR2 = "GEN/BEGIN 1ST GRD/READ SOME WORDS"
  ACBG1GR3 = "GEN/BEGIN 1ST GRD/READ SENTENCES"
  ACBG1GR4 = "GEN/BEGIN 1ST GRD/WRITE LETTERS"
  ACBG1GR5 = "GEN/BEGIN 1ST GRD/WRITE SOME WORDS"
  ACBGCUR1 = "GEN/EMPHASIS CURRICULUM/READING"
  ACBGCUR2 = "GEN/EMPHASIS CURRICULUM/WRITING"
  ACBGCUR3 = "GEN/EMPHASIS CURRICULUM/SPEAK,LISTEN"
  ACBGRWS  = "GEN/SCH HAVE/OWN STATEMENT OF RDG CUR"
  ACBGRII  = "GEN/SCH HAVE/INFORMAL INITIATIVES"
  ACBGRSP  = "GEN/SCH HAVE/SCH-BASED PROGRAMS FOR TCH"
  ACBGPOL  = "GEN/SCH POLICY/COORDINATE RDG INSTR"
  ACBGMA1  = "GEN/MATERIALS/READING SERIES"
  ACBGMA2  = "GEN/MATERIALS/TEXTBOOKS"
  ACBGMA3  = "GEN/MATERIALS/VARIETY CHD BOOKS"
  ACBGMA4  = "GEN/MATERIALS/DIFFERENT CURRICULAR AREAS"
  ACBGMA5  = "GEN/MATERIALS/CHD NEWSPAPERS+MAGAZINES"
  ACBGME1  = "GEN/MAJOR EMPHASIS/KNOWING LETTERS"
  ACBGME2  = "GEN/MAJOR EMPHASIS/LETTER-SOUND RELATION"
  ACBGME3  = "GEN/MAJOR EMPHASIS/READING WORDS"
  ACBGME4  = "GEN/MAJOR EMPHASIS/RDG ISOLATED SENTENCE"
  ACBGME5  = "GEN/MAJOR EMPHASIS/RDG CONNECTED TEXT"
  ACBGME6  = "GEN/MAJOR EMPHASIS/IDENTIFYING MAIN IDEA"
  ACBGME7  = "GEN/MAJOR EMPHASIS/EXPLAINING,SUPPORTING"
  ACBGME8  = "GEN/MAJOR EMPHASIS/PERSONAL EXPERIENCE"
  ACBGME9  = "GEN/MAJOR EMPHASIS/COMPARING DIFF TEXTS"
  ACBGME10 = "GEN/MAJOR EMPHASIS/MAKING PREDICTIONS"
  ACBGME11 = "GEN/MAJOR EMPHASIS/MAKING GENERALIZATION"
  ACBGME12 = "GEN/MAJOR EMPHASIS/DESCRIBING TEXT STYLE"
  ACBGIMPL = "GEN/IMPLEMENTATION OF RDG INSTR PROGRAM"
  ACBGLI   = "GEN/SCH LIBRARY"
  ACBGLIST = "GEN/SCH LIBRARY/STAFF"
  ACBGLIBC = "GEN/SCH LIBRARY/BOOKS CONTAIN"
  ACBGLIBM = "GEN/SCH LIBRARY/MAGAZINES CONTAIN"
  ACBGRDCR = "GEN/HOW MANY RDG CORNERS-CLSRM LIBRARIES"
  ACBGCMP1 = "GEN/NUMBER OF PC/FOR 4TH GRADE STD"
  ACBGCMP2 = "GEN/NUMBER OF PC/ACCESS TO INTERNET"
  ACBGST1  = "GEN/SHORTAGE AFFECT/INSTRUCTIONAL STAFF"
  ACBGST2  = "GEN/SHORTAGE AFFECT/TCH TEACH READING"
  ACBGST3  = "GEN/SHORTAGE AFFECT/INSTR MATERIALS"
  ACBGST4  = "GEN/SHORTAGE AFFECT/SUPPLIES"
  ACBGST5  = "GEN/SHORTAGE AFFECT/SCH BUILDING,GROUND"
  ACBGST6  = "GEN/SHORTAGE AFFECT/HEAT.LIGHTING SYSTEM"
  ACBGST7  = "GEN/SHORTAGE AFFECT/INSTRUCTIONAL SPACE"
  ACBGST8  = "GEN/SHORTAGE AFFECT/SPECIAL EQUIPMENT"
  ACBGST9  = "GEN/SHORTAGE AFFECT/COMPUTERS"
  ACBGST10 = "GEN/SHORTAGE AFFECT/PC SOFTWARE"
  ACBGST11 = "GEN/SHORTAGE AFFECT/PC SUPPORT STAFF"
  ACBGST12 = "GEN/SHORTAGE AFFECT/LIBRARY BOOKS"
  ACBGST13 = "GEN/SHORTAGE AFFECT/AUD-VISUAL RESOURCES"
  ACBGPRG1 = "GEN/PROGRAMS AVAILABLE/ADULT LITERACY"
  ACBGPRG2 = "GEN/PROGRAMS AVAILABLE/PAR EDUCATION"
  ACBGPRG3 = "GEN/PROGRAMS AVAILABLE/CHILD CARE"
  ACBGPRG4 = "GEN/PROGRAMS AVAILABLE/HEALTH SERVICE"
  ACBG4FA1 = "GEN/4GRADE+FAMILY/TCH-PAR CONFERENCE"
  ACBG4FA2 = "GEN/4GRADE+FAMILY/INFO ABOUT SCH"
  ACBG4FA3 = "GEN/4GRADE+FAMILY/WRITTEN REPORTS"
  ACBG4FA4 = "GEN/4GRADE+FAMILY/TCH HOME VISITS"
  ACBG4FA5 = "GEN/4GRADE+FAMILY/SCH EVENTS WITH PAR"
  ACBG4FA6 = "GEN/4GRADE+FAMILY/ACTIVITIES WITH PAR"
  ACBGPAR1 = "GEN/% STD WITH PAR/HELP IN SCH"
  ACBGPAR2 = "GEN/% STD WITH PAR/ATTEND CONFERENCES"
  ACBGPAR3 = "GEN/% STD WITH PAR/ATTEND SCH EVENTS"
  ACBGPAR4 = "GEN/% STD WITH PAR/DO ACTIVITIES FOR SCH"
  ACBGCHA1 = "GEN/SCH CHARACTER/TCH JOB SATISFACTION"
  ACBGCHA2 = "GEN/SCH CHARACTER/TCH EXPECTATIONS"
  ACBGCHA3 = "GEN/SCH CHARACTER/PAR SUPPORT"
  ACBGCHA4 = "GEN/SCH CHARACTER/SCH PROPERTY"
  ACBGCHA5 = "GEN/SCH CHARACTER/STD DESIRE TO DO WELL"
  ACBGPB1  = "GEN/PROBLEMS/STD TARDINESS"
  ACBGPB2  = "GEN/PROBLEMS/STD ABSENTEEISM"
  ACBGPB3  = "GEN/PROBLEMS/CLASSROOM DISTURBANCE"
  ACBGPB4  = "GEN/PROBLEMS/CHEATING"
  ACBGPB5  = "GEN/PROBLEMS/PROFANITY"
  ACBGPB6  = "GEN/PROBLEMS/VANDALISM"
  ACBGPB7  = "GEN/PROBLEMS/THEFT"
  ACBGPB8  = "GEN/PROBLEMS/ABUSE AMONG STD"
  ACBGPB9  = "GEN/PROBLEMS/PHYS CONFLICTS AMONG STD"
  ACBGPB10 = "GEN/PROBLEMS/<DRUG ABUSE>"
  ACBGPB11 = "GEN/PROBLEMS/<WEAPONS>"
  ACBGPB12 = "GEN/PROBLEMS/<RACISM>"
  ACBGPB13 = "GEN/PROBLEMS/<SEXUAL HARASSMENT>"
  ACBGCOOP = "GEN/COOPERATION+COLLABORATION AMONG TCH"
  ACBGTSTM = "GEN/FORMAL SCHEDULED TIME FOR TCH"
  ACBGACT1 = "GEN/% TIME FOR ACTS/CURRICULUM+PEDAGOGY"
  ACBGACT2 = "GEN/% TIME FOR ACTS/MANAGING STAFF"
  ACBGACT3 = "GEN/% TIME FOR ACTS/ADMINISTRATIVE DUTY"
  ACBGACT4 = "GEN/% TIME FOR ACTS/PAR+COMM RELATIONS"
  ACBGACT5 = "GEN/% TIME FOR ACTS/TEACHING"
  ACBGACT6 = "GEN/% TIME FOR ACTS/OTHER"
  ACBGCOMP = "GEN/TIME TO COMPLETE QUESTIONNAIRE"
  ACDGACTT = "Q#32 SUM OF ACTIVITIES"
  DPCDATE  = "DATE OF CREATION AT DPC"
  STOTWGTU = "TOTAL STUDENT WEIGHT"
  JKCZONE  = "JACKKNIFE ZONE"
  JKCREP   = "JACKKNIFE REPLICATE CODE"
  WGTFAC1  = "SCHOOL WEIGHTING FACTOR"
  WGTADJ1  = "SCHOOL WEIGHT ADJUSTMENT"
  SCHWGT   = "SCHOOL WEIGHT"
  ACDGIHY  = "NUMBER OF HOURS OF SCHOOL PER YEAR"
  ACDGIDYW = "NUMBER OF DAYS OF SCHOOL PER WEEK"
  ACDG4PAR = "INDEX OF HOME-SCHOOL INVOLVEMENT (HSI)"
  ACDGCHA  = "INDEX PRNCPLS PRCTPN SCHOOL CLMT (PPSC)"
  ACDGPB   = "INDEX PRNCPLS PRCTPN SCHOOL SFTY (PPSS)"
  ACDGST   = "INDEX AVAILBLTY OF SCHL RESOURCES (ASR)"
  ACDGCMP  = "AVAILBLTY OF COMPUTERS FOR INSTRUCTION"
  ACDG1GR  = "PERCNTAGES OF STDNTS WTH EARLY LIT SKLLS"
;

%PUT INFO: recode "not administered" data to missing code ".A" ;
*NOTE: If a CHECK variable is coded correctly with a BLANK, it will be recoded
       to "1", otherwise it will be recoded to "0" ;

IF IDPOP    = 8                THEN IDPOP    = .A ;
IF INPRL01  = 8                THEN INPRL01  = .A ;
IF ACBGGRD1 = 8                THEN ACBGGRD1 = .A ;
IF ACBGGRD2 = 8                THEN ACBGGRD2 = .A ;
IF ACBGGRD3 = 8                THEN ACBGGRD3 = .A ;
IF ACBGGRD4 = 8                THEN ACBGGRD4 = .A ;
IF ACBGGRD5 = 8                THEN ACBGGRD5 = .A ;
IF ACBGGRD6 = 8                THEN ACBGGRD6 = .A ;
IF ACBGGENR = 9998             THEN ACBGGENR = .A ;
IF ACBGBENR = 9998             THEN ACBGBENR = .A ;
IF ACBGG4EN = 998              THEN ACBGG4EN = .A ;
IF ACBGB4EN = 998              THEN ACBGB4EN = .A ;
IF ACBGCLOC = 8                THEN ACBGCLOC = .A ;
IF ACBGCLOS = 8                THEN ACBGCLOS = .A ;
IF ACBGCOMM = 8                THEN ACBGCOMM = .A ;
IF ACBGAVR1 = 8                THEN ACBGAVR1 = .A ;
IF ACBGAVR2 = 8                THEN ACBGAVR2 = .A ;
IF ACBGAVR3 = 8                THEN ACBGAVR3 = .A ;
IF ACBGAVR4 = 8                THEN ACBGAVR4 = .A ;
IF ACBGAVR5 = 8                THEN ACBGAVR5 = .A ;
IF ACBGAVR6 = 8                THEN ACBGAVR6 = .A ;
IF ACBGENDY = 8                THEN ACBGENDY = .A ;
IF ACBGPSS1 = 8                THEN ACBGPSS1 = .A ;
IF ACBGPSS2 = 8                THEN ACBGPSS2 = .A ;
IF ACBGPSS3 = 8                THEN ACBGPSS3 = .A ;
IF ACBGPSS4 = 8                THEN ACBGPSS4 = .A ;
IF ACBGPGS1 = 8                THEN ACBGPGS1 = .A ;
IF ACBGPGS2 = 8                THEN ACBGPGS2 = .A ;
IF ACBGPGS3 = 8                THEN ACBGPGS3 = .A ;
IF ACBGPGS4 = 8                THEN ACBGPGS4 = .A ;
IF ACBGSABI = 8                THEN ACBGSABI = .A ;
IF ACBGIDY  = 998              THEN ACBGIDY  = .A ;
IF ACBGIHD  = 98               THEN ACBGIHD  = .A ;
IF ACBGIMD  = 98               THEN ACBGIMD  = .A ;
IF ACBGIDYW = 8                THEN ACBGIDYW = .A ;
IF ACBGIDYO = 8                THEN ACBGIDYO = .A ;
IF ACBGSTST = 8                THEN ACBGSTST = .A ;
IF ACBGINF1 = 8                THEN ACBGINF1 = .A ;
IF ACBGINF2 = 8                THEN ACBGINF2 = .A ;
IF ACBGINF3 = 8                THEN ACBGINF3 = .A ;
IF ACBGINF4 = 8                THEN ACBGINF4 = .A ;
IF ACBGINF5 = 8                THEN ACBGINF5 = .A ;
IF ACBG1GR1 = 8                THEN ACBG1GR1 = .A ;
IF ACBG1GR2 = 8                THEN ACBG1GR2 = .A ;
IF ACBG1GR3 = 8                THEN ACBG1GR3 = .A ;
IF ACBG1GR4 = 8                THEN ACBG1GR4 = .A ;
IF ACBG1GR5 = 8                THEN ACBG1GR5 = .A ;
IF ACBGCUR1 = 8                THEN ACBGCUR1 = .A ;
IF ACBGCUR2 = 8                THEN ACBGCUR2 = .A ;
IF ACBGCUR3 = 8                THEN ACBGCUR3 = .A ;
IF ACBGRWS  = 8                THEN ACBGRWS  = .A ;
IF ACBGRII  = 8                THEN ACBGRII  = .A ;
IF ACBGRSP  = 8                THEN ACBGRSP  = .A ;
IF ACBGPOL  = 8                THEN ACBGPOL  = .A ;
IF ACBGMA1  = 8                THEN ACBGMA1  = .A ;
IF ACBGMA2  = 8                THEN ACBGMA2  = .A ;
IF ACBGMA3  = 8                THEN ACBGMA3  = .A ;
IF ACBGMA4  = 8                THEN ACBGMA4  = .A ;
IF ACBGMA5  = 8                THEN ACBGMA5  = .A ;
IF ACBGME1  = 8                THEN ACBGME1  = .A ;
IF ACBGME2  = 8                THEN ACBGME2  = .A ;
IF ACBGME3  = 8                THEN ACBGME3  = .A ;
IF ACBGME4  = 8                THEN ACBGME4  = .A ;
IF ACBGME5  = 8                THEN ACBGME5  = .A ;
IF ACBGME6  = 8                THEN ACBGME6  = .A ;
IF ACBGME7  = 8                THEN ACBGME7  = .A ;
IF ACBGME8  = 8                THEN ACBGME8  = .A ;
IF ACBGME9  = 8                THEN ACBGME9  = .A ;
IF ACBGME10 = 8                THEN ACBGME10 = .A ;
IF ACBGME11 = 8                THEN ACBGME11 = .A ;
IF ACBGME12 = 8                THEN ACBGME12 = .A ;
IF ACBGIMPL = 8                THEN ACBGIMPL = .A ;
IF ACBGLI   = 8                THEN ACBGLI   = .A ;
IF ACBGLIST = 8                THEN ACBGLIST = .A ;
IF ACBGLIBC = 98               THEN ACBGLIBC = .A ;
IF ACBGLIBM = 8                THEN ACBGLIBM = .A ;
IF ACBGRDCR = 8                THEN ACBGRDCR = .A ;
IF ACBGCMP1 = 998              THEN ACBGCMP1 = .A ;
IF ACBGCMP2 = 8                THEN ACBGCMP2 = .A ;
IF ACBGST1  = 8                THEN ACBGST1  = .A ;
IF ACBGST2  = 8                THEN ACBGST2  = .A ;
IF ACBGST3  = 8                THEN ACBGST3  = .A ;
IF ACBGST4  = 8                THEN ACBGST4  = .A ;
IF ACBGST5  = 8                THEN ACBGST5  = .A ;
IF ACBGST6  = 8                THEN ACBGST6  = .A ;
IF ACBGST7  = 8                THEN ACBGST7  = .A ;
IF ACBGST8  = 8                THEN ACBGST8  = .A ;
IF ACBGST9  = 8                THEN ACBGST9  = .A ;
IF ACBGST10 = 8                THEN ACBGST10 = .A ;
IF ACBGST11 = 8                THEN ACBGST11 = .A ;
IF ACBGST12 = 8                THEN ACBGST12 = .A ;
IF ACBGST13 = 8                THEN ACBGST13 = .A ;
IF ACBGPRG1 = 8                THEN ACBGPRG1 = .A ;
IF ACBGPRG2 = 8                THEN ACBGPRG2 = .A ;
IF ACBGPRG3 = 8                THEN ACBGPRG3 = .A ;
IF ACBGPRG4 = 8                THEN ACBGPRG4 = .A ;
IF ACBG4FA1 = 8                THEN ACBG4FA1 = .A ;
IF ACBG4FA2 = 8                THEN ACBG4FA2 = .A ;
IF ACBG4FA3 = 8                THEN ACBG4FA3 = .A ;
IF ACBG4FA4 = 8                THEN ACBG4FA4 = .A ;
IF ACBG4FA5 = 8                THEN ACBG4FA5 = .A ;
IF ACBG4FA6 = 8                THEN ACBG4FA6 = .A ;
IF ACBGPAR1 = 8                THEN ACBGPAR1 = .A ;
IF ACBGPAR2 = 8                THEN ACBGPAR2 = .A ;
IF ACBGPAR3 = 8                THEN ACBGPAR3 = .A ;
IF ACBGPAR4 = 8                THEN ACBGPAR4 = .A ;
IF ACBGCHA1 = 8                THEN ACBGCHA1 = .A ;
IF ACBGCHA2 = 8                THEN ACBGCHA2 = .A ;
IF ACBGCHA3 = 8                THEN ACBGCHA3 = .A ;
IF ACBGCHA4 = 8                THEN ACBGCHA4 = .A ;
IF ACBGCHA5 = 8                THEN ACBGCHA5 = .A ;
IF ACBGPB1  = 8                THEN ACBGPB1  = .A ;
IF ACBGPB2  = 8                THEN ACBGPB2  = .A ;
IF ACBGPB3  = 8                THEN ACBGPB3  = .A ;
IF ACBGPB4  = 8                THEN ACBGPB4  = .A ;
IF ACBGPB5  = 8                THEN ACBGPB5  = .A ;
IF ACBGPB6  = 8                THEN ACBGPB6  = .A ;
IF ACBGPB7  = 8                THEN ACBGPB7  = .A ;
IF ACBGPB8  = 8                THEN ACBGPB8  = .A ;
IF ACBGPB9  = 8                THEN ACBGPB9  = .A ;
IF ACBGPB10 = 8                THEN ACBGPB10 = .A ;
IF ACBGPB11 = 8                THEN ACBGPB11 = .A ;
IF ACBGPB12 = 8                THEN ACBGPB12 = .A ;
IF ACBGPB13 = 8                THEN ACBGPB13 = .A ;
IF ACBGCOOP = 8                THEN ACBGCOOP = .A ;
IF ACBGTSTM = 8                THEN ACBGTSTM = .A ;
IF ACBGACT1 = 998              THEN ACBGACT1 = .A ;
IF ACBGACT2 = 998              THEN ACBGACT2 = .A ;
IF ACBGACT3 = 998              THEN ACBGACT3 = .A ;
IF ACBGACT4 = 998              THEN ACBGACT4 = .A ;
IF ACBGACT5 = 998              THEN ACBGACT5 = .A ;
IF ACBGACT6 = 998              THEN ACBGACT6 = .A ;
IF ACBGCOMP = 998              THEN ACBGCOMP = .A ;
IF ACDGACTT = 998              THEN ACDGACTT = .A ;
IF STOTWGTU = 999998           THEN STOTWGTU = .A ;
IF JKCZONE  = 98               THEN JKCZONE  = .A ;
IF JKCREP   = 8                THEN JKCREP   = .A ;
IF WGTFAC1  = 999998           THEN WGTFAC1  = .A ;
IF WGTADJ1  = 999998           THEN WGTADJ1  = .A ;
IF SCHWGT   = 999998           THEN SCHWGT   = .A ;
IF ACDGIHY  = 9998             THEN ACDGIHY  = .A ;
IF ACDGIDYW = 8                THEN ACDGIDYW = .A ;
IF ACDG4PAR = 8                THEN ACDG4PAR = .A ;
IF ACDGCHA  = 8                THEN ACDGCHA  = .A ;
IF ACDGPB   = 8                THEN ACDGPB   = .A ;
IF ACDGST   = 8                THEN ACDGST   = .A ;
IF ACDGCMP  = 8                THEN ACDGCMP  = .A ;
IF ACDG1GR  = 8                THEN ACDG1GR  = .A ;

%PUT INFO: recode special missing codes to SAS missing codes ;
*NOTE: Special missing codes are recoded to SAS
       character - missing codes;

IF ACBGCLOS = 6                THEN ACBGCLOS = .B ;
IF ACBGLIST = 6                THEN ACBGLIST = .B ;
IF ACBGLIBC = 96               THEN ACBGLIBC = .B ;
IF ACBGLIBM = 6                THEN ACBGLIBM = .B ;
IF ACBGCMP2 = 6                THEN ACBGCMP2 = .B ;

%PUT INFO: recode omitted data to missing code "." ;
*NOTE: BLANKS are recoded to SYSMIS by SAS ;

IF IDPOP    = 9                THEN IDPOP    = . ;
IF INPRL01  = 9                THEN INPRL01  = . ;
IF ACBGGRD1 = 9                THEN ACBGGRD1 = . ;
IF ACBGGRD2 = 9                THEN ACBGGRD2 = . ;
IF ACBGGRD3 = 9                THEN ACBGGRD3 = . ;
IF ACBGGRD4 = 9                THEN ACBGGRD4 = . ;
IF ACBGGRD5 = 9                THEN ACBGGRD5 = . ;
IF ACBGGRD6 = 9                THEN ACBGGRD6 = . ;
IF ACBGGENR = 9999             THEN ACBGGENR = . ;
IF ACBGBENR = 9999             THEN ACBGBENR = . ;
IF ACBGG4EN = 999              THEN ACBGG4EN = . ;
IF ACBGB4EN = 999              THEN ACBGB4EN = . ;
IF ACBGCLOC = 9                THEN ACBGCLOC = . ;
IF ACBGCLOS = 9                THEN ACBGCLOS = . ;
IF ACBGCOMM = 9                THEN ACBGCOMM = . ;
IF ACBGAVR1 = 9                THEN ACBGAVR1 = . ;
IF ACBGAVR2 = 9                THEN ACBGAVR2 = . ;
IF ACBGAVR3 = 9                THEN ACBGAVR3 = . ;
IF ACBGAVR4 = 9                THEN ACBGAVR4 = . ;
IF ACBGAVR5 = 9                THEN ACBGAVR5 = . ;
IF ACBGAVR6 = 9                THEN ACBGAVR6 = . ;
IF ACBGENDY = 9                THEN ACBGENDY = . ;
IF ACBGPSS1 = 9                THEN ACBGPSS1 = . ;
IF ACBGPSS2 = 9                THEN ACBGPSS2 = . ;
IF ACBGPSS3 = 9                THEN ACBGPSS3 = . ;
IF ACBGPSS4 = 9                THEN ACBGPSS4 = . ;
IF ACBGPGS1 = 9                THEN ACBGPGS1 = . ;
IF ACBGPGS2 = 9                THEN ACBGPGS2 = . ;
IF ACBGPGS3 = 9                THEN ACBGPGS3 = . ;
IF ACBGPGS4 = 9                THEN ACBGPGS4 = . ;
IF ACBGSABI = 9                THEN ACBGSABI = . ;
IF ACBGIDY  = 999              THEN ACBGIDY  = . ;
IF ACBGIHD  = 99               THEN ACBGIHD  = . ;
IF ACBGIMD  = 99               THEN ACBGIMD  = . ;
IF ACBGIDYW = 9                THEN ACBGIDYW = . ;
IF ACBGIDYO = 9                THEN ACBGIDYO = . ;
IF ACBGSTST = 9                THEN ACBGSTST = . ;
IF ACBGINF1 = 9                THEN ACBGINF1 = . ;
IF ACBGINF2 = 9                THEN ACBGINF2 = . ;
IF ACBGINF3 = 9                THEN ACBGINF3 = . ;
IF ACBGINF4 = 9                THEN ACBGINF4 = . ;
IF ACBGINF5 = 9                THEN ACBGINF5 = . ;
IF ACBG1GR1 = 9                THEN ACBG1GR1 = . ;
IF ACBG1GR2 = 9                THEN ACBG1GR2 = . ;
IF ACBG1GR3 = 9                THEN ACBG1GR3 = . ;
IF ACBG1GR4 = 9                THEN ACBG1GR4 = . ;
IF ACBG1GR5 = 9                THEN ACBG1GR5 = . ;
IF ACBGCUR1 = 9                THEN ACBGCUR1 = . ;
IF ACBGCUR2 = 9                THEN ACBGCUR2 = . ;
IF ACBGCUR3 = 9                THEN ACBGCUR3 = . ;
IF ACBGRWS  = 9                THEN ACBGRWS  = . ;
IF ACBGRII  = 9                THEN ACBGRII  = . ;
IF ACBGRSP  = 9                THEN ACBGRSP  = . ;
IF ACBGPOL  = 9                THEN ACBGPOL  = . ;
IF ACBGMA1  = 9                THEN ACBGMA1  = . ;
IF ACBGMA2  = 9                THEN ACBGMA2  = . ;
IF ACBGMA3  = 9                THEN ACBGMA3  = . ;
IF ACBGMA4  = 9                THEN ACBGMA4  = . ;
IF ACBGMA5  = 9                THEN ACBGMA5  = . ;
IF ACBGME1  = 9                THEN ACBGME1  = . ;
IF ACBGME2  = 9                THEN ACBGME2  = . ;
IF ACBGME3  = 9                THEN ACBGME3  = . ;
IF ACBGME4  = 9                THEN ACBGME4  = . ;
IF ACBGME5  = 9                THEN ACBGME5  = . ;
IF ACBGME6  = 9                THEN ACBGME6  = . ;
IF ACBGME7  = 9                THEN ACBGME7  = . ;
IF ACBGME8  = 9                THEN ACBGME8  = . ;
IF ACBGME9  = 9                THEN ACBGME9  = . ;
IF ACBGME10 = 9                THEN ACBGME10 = . ;
IF ACBGME11 = 9                THEN ACBGME11 = . ;
IF ACBGME12 = 9                THEN ACBGME12 = . ;
IF ACBGIMPL = 9                THEN ACBGIMPL = . ;
IF ACBGLI   = 9                THEN ACBGLI   = . ;
IF ACBGLIST = 9                THEN ACBGLIST = . ;
IF ACBGLIBC = 99               THEN ACBGLIBC = . ;
IF ACBGLIBM = 9                THEN ACBGLIBM = . ;
IF ACBGRDCR = 9                THEN ACBGRDCR = . ;
IF ACBGCMP1 = 999              THEN ACBGCMP1 = . ;
IF ACBGCMP2 = 9                THEN ACBGCMP2 = . ;
IF ACBGST1  = 9                THEN ACBGST1  = . ;
IF ACBGST2  = 9                THEN ACBGST2  = . ;
IF ACBGST3  = 9                THEN ACBGST3  = . ;
IF ACBGST4  = 9                THEN ACBGST4  = . ;
IF ACBGST5  = 9                THEN ACBGST5  = . ;
IF ACBGST6  = 9                THEN ACBGST6  = . ;
IF ACBGST7  = 9                THEN ACBGST7  = . ;
IF ACBGST8  = 9                THEN ACBGST8  = . ;
IF ACBGST9  = 9                THEN ACBGST9  = . ;
IF ACBGST10 = 9                THEN ACBGST10 = . ;
IF ACBGST11 = 9                THEN ACBGST11 = . ;
IF ACBGST12 = 9                THEN ACBGST12 = . ;
IF ACBGST13 = 9                THEN ACBGST13 = . ;
IF ACBGPRG1 = 9                THEN ACBGPRG1 = . ;
IF ACBGPRG2 = 9                THEN ACBGPRG2 = . ;
IF ACBGPRG3 = 9                THEN ACBGPRG3 = . ;
IF ACBGPRG4 = 9                THEN ACBGPRG4 = . ;
IF ACBG4FA1 = 9                THEN ACBG4FA1 = . ;
IF ACBG4FA2 = 9                THEN ACBG4FA2 = . ;
IF ACBG4FA3 = 9                THEN ACBG4FA3 = . ;
IF ACBG4FA4 = 9                THEN ACBG4FA4 = . ;
IF ACBG4FA5 = 9                THEN ACBG4FA5 = . ;
IF ACBG4FA6 = 9                THEN ACBG4FA6 = . ;
IF ACBGPAR1 = 9                THEN ACBGPAR1 = . ;
IF ACBGPAR2 = 9                THEN ACBGPAR2 = . ;
IF ACBGPAR3 = 9                THEN ACBGPAR3 = . ;
IF ACBGPAR4 = 9                THEN ACBGPAR4 = . ;
IF ACBGCHA1 = 9                THEN ACBGCHA1 = . ;
IF ACBGCHA2 = 9                THEN ACBGCHA2 = . ;
IF ACBGCHA3 = 9                THEN ACBGCHA3 = . ;
IF ACBGCHA4 = 9                THEN ACBGCHA4 = . ;
IF ACBGCHA5 = 9                THEN ACBGCHA5 = . ;
IF ACBGPB1  = 9                THEN ACBGPB1  = . ;
IF ACBGPB2  = 9                THEN ACBGPB2  = . ;
IF ACBGPB3  = 9                THEN ACBGPB3  = . ;
IF ACBGPB4  = 9                THEN ACBGPB4  = . ;
IF ACBGPB5  = 9                THEN ACBGPB5  = . ;
IF ACBGPB6  = 9                THEN ACBGPB6  = . ;
IF ACBGPB7  = 9                THEN ACBGPB7  = . ;
IF ACBGPB8  = 9                THEN ACBGPB8  = . ;
IF ACBGPB9  = 9                THEN ACBGPB9  = . ;
IF ACBGPB10 = 9                THEN ACBGPB10 = . ;
IF ACBGPB11 = 9                THEN ACBGPB11 = . ;
IF ACBGPB12 = 9                THEN ACBGPB12 = . ;
IF ACBGPB13 = 9                THEN ACBGPB13 = . ;
IF ACBGCOOP = 9                THEN ACBGCOOP = . ;
IF ACBGTSTM = 9                THEN ACBGTSTM = . ;
IF ACBGACT1 = 999              THEN ACBGACT1 = . ;
IF ACBGACT2 = 999              THEN ACBGACT2 = . ;
IF ACBGACT3 = 999              THEN ACBGACT3 = . ;
IF ACBGACT4 = 999              THEN ACBGACT4 = . ;
IF ACBGACT5 = 999              THEN ACBGACT5 = . ;
IF ACBGACT6 = 999              THEN ACBGACT6 = . ;
IF ACBGCOMP = 999              THEN ACBGCOMP = . ;
IF ACDGACTT = 999              THEN ACDGACTT = . ;
IF STOTWGTU = 999999           THEN STOTWGTU = . ;
IF JKCZONE  = 99               THEN JKCZONE  = . ;
IF JKCREP   = 9                THEN JKCREP   = . ;
IF WGTFAC1  = 999999           THEN WGTFAC1  = . ;
IF WGTADJ1  = 999999           THEN WGTADJ1  = . ;
IF SCHWGT   = 999999           THEN SCHWGT   = . ;
IF ACDGIHY  = 9999             THEN ACDGIHY  = . ;
IF ACDGIDYW = 9                THEN ACDGIDYW = . ;
IF ACDG4PAR = 9                THEN ACDG4PAR = . ;
IF ACDGCHA  = 9                THEN ACDGCHA  = . ;
IF ACDGPB   = 9                THEN ACDGPB   = . ;
IF ACDGST   = 9                THEN ACDGST   = . ;
IF ACDGCMP  = 9                THEN ACDGCMP  = . ;
IF ACDG1GR  = 9                THEN ACDG1GR  = . ;

%PUT INFO: assign variable labels to recoded variables ;
LABEL
;

proc sort ; by idcntry idschool;

       %let i = %eval(&i + 1);
     %end;
run;
%mend doit;

%doit;






