%let cty = ARG BGR BLZ CAN COL CYP CZE DEU ENG FRA
           GRC HKG HUN IRN ISL ISR ITA KWT LTU LVA
           MAR MDA MKD NLD NOR NZL ROM RUS SCO SGP
           SVK SVN SWE TUR USA SE3;

Options nosource nocenter;

LIBNAME libdat  "c:\pirls\Data" ;
LIBNAME library "c:\pirls\Data" ;

%macro doit;
  %let i = 1;
     %do %while(%length(%scan(&cty,&i)));
       %let ccode = %lowcase(%scan(&cty,&i));

%let fname= asa&ccode.r1 ;

FILENAME rawinp "c:\pirls\Data\&fname..dat" ;

%PUT INFO: data set definition ;
%PUT INFO: data set definitions may need to be modified ;

*Output data set ;
data libdat.&fname;

*NOTE: LRECL may need to be modified ;
INFILE rawinp LRECL=1250 END=eof LENGTH=lnline LINE=ln MISSOVER ;

%PUT INFO: shorten variable definitions to save secondary storage area ;
%PUT INFO: refer to the SAS manual for an appropriate length for variables ;

*NOTE: The LENGTH statement in a data step specifies the number of bytes, the
       SAS - sytem uses for storing values of variables in each data set being created. ;
LENGTH DEFAULT=5 ;
LENGTH      IDBOOK     3 ;
LENGTH      IDCNTRY    5 ;
LENGTH      IDSCHOOL   4 ;
LENGTH      IDCLASS    6 ;
LENGTH      IDSTUD     8 ;
LENGTH      ITLANG     3 ;
LENGTH      IDPOP      3 ;
LENGTH      IDGRADER   3 ;
LENGTH      INPRL01    3 ;
LENGTH      R011M01M   3 ;
LENGTH      R011M02M   3 ;
LENGTH      R011M03M   3 ;
LENGTH      R011M04C   3 ;
LENGTH      R011M05M   3 ;
LENGTH      R011M06C   3 ;
LENGTH      R011M07C   3 ;
LENGTH      R011M08M   3 ;
LENGTH      R011M09M   3 ;
LENGTH      R011M10C   3 ;
LENGTH      R011M11C   3 ;
LENGTH      R011M12C   3 ;
LENGTH      R011M13M   3 ;
LENGTH      R011M14C   3 ;
LENGTH      R011C01C   3 ;
LENGTH      R011C02C   3 ;
LENGTH      R011C03C   3 ;
LENGTH      R011C04M   3 ;
LENGTH      R011C05M   3 ;
LENGTH      R011C06C   3 ;
LENGTH      R011C07M   3 ;
LENGTH      R011C08C   3 ;
LENGTH      R011C09M   3 ;
LENGTH      R011C10C   3 ;
LENGTH      R011C11C   3 ;
LENGTH      R011C12M   3 ;
LENGTH      R011C13M   3 ;
LENGTH      R011F01M   3 ;
LENGTH      R011F02M   3 ;
LENGTH      R011F03M   3 ;
LENGTH      R011F04M   3 ;
LENGTH      R011F05M   3 ;
LENGTH      R011F06C   3 ;
LENGTH      R011F07C   3 ;
LENGTH      R011F08C   3 ;
LENGTH      R011F09C   3 ;
LENGTH      R011F10C   3 ;
LENGTH      R011F11M   3 ;
LENGTH      R011F12C   3 ;
LENGTH      R011F13M   3 ;
LENGTH      R011A01C   3 ;
LENGTH      R011A02M   3 ;
LENGTH      R011A03C   3 ;
LENGTH      R011A04C   3 ;
LENGTH      R011A05M   3 ;
LENGTH      R011A06M   3 ;
LENGTH      R011A07C   3 ;
LENGTH      R011A08C   3 ;
LENGTH      R011A09C   3 ;
LENGTH      R011A10M   3 ;
LENGTH      R011A11C   3 ;
LENGTH      R011L01M   3 ;
LENGTH      R011L02M   3 ;
LENGTH      R011L03C   3 ;
LENGTH      R011L04C   3 ;
LENGTH      R011L05M   3 ;
LENGTH      R011L06C   3 ;
LENGTH      R011L07M   3 ;
LENGTH      R011L08C   3 ;
LENGTH      R011L09M   3 ;
LENGTH      R011L10C   3 ;
LENGTH      R011L11M   3 ;
LENGTH      R011L12C   3 ;
LENGTH      R011R01M   3 ;
LENGTH      R011R02M   3 ;
LENGTH      R011R03M   3 ;
LENGTH      R011R04C   3 ;
LENGTH      R011R05C   3 ;
LENGTH      R011R06C   3 ;
LENGTH      R011R07C   3 ;
LENGTH      R011R08C   3 ;
LENGTH      R011R09C   3 ;
LENGTH      R011R10C   3 ;
LENGTH      R011R11C   3 ;
LENGTH      R011H01M   3 ;
LENGTH      R011H02M   3 ;
LENGTH      R011H03C   3 ;
LENGTH      R011H04C   3 ;
LENGTH      R011H05M   3 ;
LENGTH      R011H06M   3 ;
LENGTH      R011H07C   3 ;
LENGTH      R011H08C   3 ;
LENGTH      R011H09C   3 ;
LENGTH      R011H10C   3 ;
LENGTH      R011H11M   3 ;
LENGTH      R011N01M   3 ;
LENGTH      R011N02M   3 ;
LENGTH      R011N03M   3 ;
LENGTH      R011N04M   3 ;
LENGTH      R011N05M   3 ;
LENGTH      R011N06M   3 ;
LENGTH      R011N07C   3 ;
LENGTH      R011N08C   3 ;
LENGTH      R011N09M   3 ;
LENGTH      R011N10C   3 ;
LENGTH      R011N11M   3 ;
LENGTH      R011N12C   3 ;
LENGTH      R011N13C   3 ;
LENGTH      ASREARSC   8 ;
LENGTH      ASINFRSC   8 ;
LENGTH      ASLITRSC   8 ;
LENGTH      ASANRSC    8 ;
LENGTH      ASASCPT    8 ;
LENGTH      ASASTDR    8 ;
LENGTH      ASCNRSC    8 ;
LENGTH      ASCSCPT    8 ;
LENGTH      ASCSTDR    8 ;
LENGTH      ASFNRSC    8 ;
LENGTH      ASFSCPT    8 ;
LENGTH      ASFSTDR    8 ;
LENGTH      ASHNRSC    8 ;
LENGTH      ASHSCPT    8 ;
LENGTH      ASHSTDR    8 ;
LENGTH      ASLNRSC    8 ;
LENGTH      ASLSCPT    8 ;
LENGTH      ASLSTDR    8 ;
LENGTH      ASMNRSC    8 ;
LENGTH      ASMSCPT    8 ;
LENGTH      ASMSTDR    8 ;
LENGTH      ASNNRSC    8 ;
LENGTH      ASNSCPT    8 ;
LENGTH      ASNSTDR    8 ;
LENGTH      ASRNRSC    8 ;
LENGTH      ASRSCPT    8 ;
LENGTH      ASRSTDR    8 ;
LENGTH      ITPART     3 ;
LENGTH      DPCDATE    6 ;
LENGTH      HOUWGT     8 ;
LENGTH      TOTWGT     8 ;
LENGTH      SENWGT     8 ;
LENGTH      JKZONE     3 ;
LENGTH      JKREP      3 ;
LENGTH      IDSTRATE   3 ;
LENGTH      IDSTRATI   3 ;
LENGTH      ASRINF01   8 ;
LENGTH      ASRINF02   8 ;
LENGTH      ASRINF03   8 ;
LENGTH      ASRINF04   8 ;
LENGTH      ASRINF05   8 ;
LENGTH      ASRLIT01   8 ;
LENGTH      ASRLIT02   8 ;
LENGTH      ASRLIT03   8 ;
LENGTH      ASRLIT04   8 ;
LENGTH      ASRLIT05   8 ;
LENGTH      ASRREA01   8 ;
LENGTH      ASRREA02   8 ;
LENGTH      ASRREA03   8 ;
LENGTH      ASRREA04   8 ;
LENGTH      ASRREA05   8 ;


%PUT INFO: Missing category A refers to "not administered" values ;
%PUT INFO: Missing category I refers to "invalid" values ;
%PUT INFO: Missing category B refers to "logically not applicable" values ;
%PUT INFO: Missing category R refers to "not reached" items ;
%PUT INFO: Missing category . refers to missing values ;
MISSING A I B R ;

*NOTE: The INPUT statement reads raw data and assigns variable names.
       The positions specified below correspond to the positions of the variables
       in the raw data file. ;

INPUT
  IDBOOK        1-   2     
  IDCNTRY       3-   7     
  IDSCHOOL      8-  11     
  IDCLASS      12-  17     
  IDSTUD       18-  25     
  ITLANG       26-  26     
  IDPOP        27-  27     
  IDGRADER     28-  28     
  INPRL01      29-  29     
  R011M01M     30-  30     
  R011M02M     31-  31     
  R011M03M     32-  32     
  R011M04C     33-  33     
  R011M05M     34-  34     
  R011M06C     35-  35     
  R011M07C     36-  36     
  R011M08M     37-  37     
  R011M09M     38-  38     
  R011M10C     39-  39     
  R011M11C     40-  40     
  R011M12C     41-  41     
  R011M13M     42-  42     
  R011M14C     43-  43     
  R011C01C     44-  44     
  R011C02C     45-  45     
  R011C03C     46-  46     
  R011C04M     47-  47     
  R011C05M     48-  48     
  R011C06C     49-  49     
  R011C07M     50-  50     
  R011C08C     51-  51     
  R011C09M     52-  52     
  R011C10C     53-  53     
  R011C11C     54-  54     
  R011C12M     55-  55     
  R011C13M     56-  56     
  R011F01M     57-  57     
  R011F02M     58-  58     
  R011F03M     59-  59     
  R011F04M     60-  60     
  R011F05M     61-  61     
  R011F06C     62-  62     
  R011F07C     63-  63     
  R011F08C     64-  64     
  R011F09C     65-  65     
  R011F10C     66-  66     
  R011F11M     67-  67     
  R011F12C     68-  68     
  R011F13M     69-  69     
  R011A01C     70-  70     
  R011A02M     71-  71     
  R011A03C     72-  72     
  R011A04C     73-  73     
  R011A05M     74-  74     
  R011A06M     75-  75     
  R011A07C     76-  76     
  R011A08C     77-  77     
  R011A09C     78-  78     
  R011A10M     79-  79     
  R011A11C     80-  80     
  R011L01M     81-  81     
  R011L02M     82-  82     
  R011L03C     83-  83     
  R011L04C     84-  84     
  R011L05M     85-  85     
  R011L06C     86-  86     
  R011L07M     87-  87     
  R011L08C     88-  88     
  R011L09M     89-  89     
  R011L10C     90-  90     
  R011L11M     91-  91     
  R011L12C     92-  92     
  R011R01M     93-  93     
  R011R02M     94-  94     
  R011R03M     95-  95     
  R011R04C     96-  96     
  R011R05C     97-  97     
  R011R06C     98-  98     
  R011R07C     99-  99     
  R011R08C    100- 100     
  R011R09C    101- 101     
  R011R10C    102- 102     
  R011R11C    103- 103     
  R011H01M    104- 104     
  R011H02M    105- 105     
  R011H03C    106- 106     
  R011H04C    107- 107     
  R011H05M    108- 108     
  R011H06M    109- 109     
  R011H07C    110- 110     
  R011H08C    111- 111     
  R011H09C    112- 112     
  R011H10C    113- 113     
  R011H11M    114- 114     
  R011N01M    115- 115     
  R011N02M    116- 116     
  R011N03M    117- 117     
  R011N04M    118- 118     
  R011N05M    119- 119     
  R011N06M    120- 120     
  R011N07C    121- 121     
  R011N08C    122- 122     
  R011N09M    123- 123     
  R011N10C    124- 124     
  R011N11M    125- 125     
  R011N12C    126- 126     
  R011N13C    127- 127     
  ASREARSC    128- 135 .3
  ASINFRSC    136- 143 .3
  ASLITRSC    144- 151 .3
  ASANRSC     152- 159 .3
  ASASCPT     160- 167 .3
  ASASTDR     168- 175 .3
  ASCNRSC     176- 183 .3
  ASCSCPT     184- 191 .3
  ASCSTDR     192- 199 .3
  ASFNRSC     200- 207 .3
  ASFSCPT     208- 215 .3
  ASFSTDR     216- 223 .3
  ASHNRSC     224- 231 .3
  ASHSCPT     232- 239 .3
  ASHSTDR     240- 247 .3
  ASLNRSC     248- 255 .3
  ASLSCPT     256- 263 .3
  ASLSTDR     264- 271 .3
  ASMNRSC     272- 279 .3
  ASMSCPT     280- 287 .3
  ASMSTDR     288- 295 .3
  ASNNRSC     296- 303 .3
  ASNSCPT     304- 311 .3
  ASNSTDR     312- 319 .3
  ASRNRSC     320- 327 .3
  ASRSCPT     328- 335 .3
  ASRSTDR     336- 343 .3
  ITPART      344- 344     
  DPCDATE     345- 350     
  HOUWGT      351- 363 .6
  TOTWGT      364- 376 .6
  SENWGT      377- 389 .6
  JKZONE      390- 391     
  JKREP       392- 392     
  IDSTRATE    393- 395     
  IDSTRATI    396- 398     
  ASRINF01    399- 411 .6
  ASRINF02    412- 424 .6
  ASRINF03    425- 437 .6
  ASRINF04    438- 450 .6
  ASRINF05    451- 463 .6
  ASRLIT01    464- 476 .6
  ASRLIT02    477- 489 .6
  ASRLIT03    490- 502 .6
  ASRLIT04    503- 515 .6
  ASRLIT05    516- 528 .6
  ASRREA01    529- 541 .6
  ASRREA02    542- 554 .6
  ASRREA03    555- 567 .6
  ASRREA04    568- 580 .6
  ASRREA05    581- 593 .6
;

%PUT INFO: assign labels to variables ;
LABEL
  IDBOOK   = "*BOOKLET ID*"
  IDCNTRY  = "*COUNTRY ID*"
  IDSCHOOL = "*SCHOOL ID*"
  IDCLASS  = "*CLASS ID*"
  IDSTUD   = "*STUDENT ID*"
  ITLANG   = "*LANGUAGE OF TESTING*"
  IDPOP    = "POPULATION INDICATOR"
  IDGRADER = "LOWER/UPPER OF TARGET GRADE"
  INPRL01  = "IN PIRLS 2001"
  R011M01M = "MICE/REASON TO GET RID OF MICE(B)"
  R011M02M = "MICE/PLACE LABON PUT THE MOUSETRAPS(D)"
  R011M03M = "MICE/REASON MICE WERE NUDGING EACHOTH(B)"
  R011M04C = "MICE/REASON LABON SMILED(1)"
  R011M05M = "MICE/LABONS ACTION AFTER STUCK CHAIR(C)"
  R011M06C = "MICE/PLACE MICE THOUGHT ABOUT STANDG(2)"
  R011M07C = "MICE/SENTENCE THAT SHOWS PANIC(1)"
  R011M08M = "MICE/HOW STORY CONVEYS MICE THOUGHTS(C)"
  R011M09M = "MICE/REASON FLOOR WAS COVERED W MICE(A)"
  R011M10C = "MICE/PLACE LABON PUT THE MICE(1)"
  R011M11C = "MICE/MICE WERE EASY TO FOOL(1)"
  R011M12C = "MICE/WHAT LABON IS LIKE(3)"
  R011M13M = "MICE/WORDS THAT BEST DESCRIBE STORY(C)"
  R011M14C = "MICE/WHAT MAKES STORY UNBELIEVABLE(1)"
  R011C01C = "CLAY/ORDER OF EVENTS IN STORY(1)"
  R011C02C = "CLAY/CLAY WAS IN BIN FOR SO LONG(1)"
  R011C03C = "CLAY/CLAYS WISH(1)"
  R011C04M = "CLAY/CLAY WAS TAKEN OUT OF BIN(A)"
  R011C05M = "CLAY/BOYS CARELESS ACTION(C)"
  R011C06C = "CLAY/BOY LEFT LUMP OF CLAY IN DANGER(1)"
  R011C07M = "CLAY/CLAYS FEELINGS AFTER BOY LEFT(B)"
  R011C08C = "CLAY/WONDERFUL THING THAT HAPPENED(2)"
  R011C09M = "CLAY/GIRL KNEW WHAT SHE WANTED 2 MAKE(D)"
  R011C10C = "CLAY/CLAYS DIFFERENT FEELINGS(3)"
  R011C11C = "CLAY/LITTLE GIRL=IMPORTANT PERSON(2)"
  R011C12M = "CLAY/AUTHOR WRITES ABOUT CLAY=PERSON(B)"
  R011C13M = "CLAY/MAIN MESSAGE OF STORY(C)"
  R011F01M = "FLOWERS/IDENTITY OF NARRATOR(B)"
  R011F02M = "FLOWERS/GRANNYS FARMHOUSE(C)"
  R011F03M = "FLOWERS/REASON GRANNY SHOULD MOVE(D)"
  R011F04M = "FLOWERS/WHO OFFERED 2 LOOK 4 ANIMALS(A)"
  R011F05M = "FLOWERS/GRANNY WAS UNHAPPY(D)"
  R011F06C = "FLOWERS/GRANNY SCREAMED(1)"
  R011F07C = "FLOWERS/GRANNY CROUCHED DOWN(2)"
  R011F08C = "FLOWERS/GRANNY WINKED AND GRINNED(1)"
  R011F09C = "FLOWERS/GRANNY MADE NEW FLAT LK HOME(2)"
  R011F10C = "FLOWERS/HOW GRANNY FEELS AT THE END(1)"
  R011F11M = "FLOWERS/PURPOSE OF LAST LINE OF STORY(A)"
  R011F12C = "FLOWERS/LITTLE BOYS FEELINGS(3)"
  R011F13M = "FLOWERS/LESSON LEARNED FROM STORY(B)"
  R011A01C = "ANTARCTICA/LOCATION OF ANTARCTICA(1)"
  R011A02M = "ANTARCTICA/RECORDS ANTARCTICA HOLDS(C)"
  R011A03C = "ANTARCTICA/COLDEST PART OF ANTARCTICA(1)"
  R011A04C = "ANTARCTICA/REASONS FOR VISITING-TIME(2)"
  R011A05M = "ANTARCTICA/MUG OF BOILG WATER FREEZES(D)"
  R011A06M = "ANTARCTICA/PURPOSE OF PENGUINS WINGS(B)"
  R011A07C = "ANTARCTICA/WAYS PENGUINS KEEP WARM(3)"
  R011A08C = "ANTARCTICA/FOOD IN ANTARCTICA(2)"
  R011A09C = "ANTARCTICA/WHETHER U WOULD LK 2 VISIT(2)"
  R011A10M = "ANTARCTICA/THICKNESS OF ICE(A)"
  R011A11C = "ANTARCTICA/INTERESTING INFORMATION(1)"
  R011L01M = "LEONARDO/LEONARDOS OCCUPATION(C)"
  R011L02M = "LEONARDO/HIS CHILDHOOD EXPERIENCE(B)"
  R011L03C = "LEONARDO/REASON VERROCCHIO WAS FAMOUS(1)"
  R011L04C = "LEONARDO/WHAT DA VINCI LEARNED FR HIM(3)"
  R011L05M = "LEONARDO/MEANING HUNGRY FOR KNOWLEDGE(A)"
  R011L06C = "LEONARDO/REASON 4 NOTEBKS IMPORTANCE(1)"
  R011L07M = "LEONARDO/REASON 4 NOT USG INVENTIONS(C)"
  R011L08C = "LEONARDO/WHAT STUDIED IN NATURE(2)"
  R011L09M = "LEONARDO/YEAR PARACHUTE FIRST USED(C)"
  R011L10C = "LEONARDO/HOW WAS HE AHEAD OF HIS TIME(2)"
  R011L11M = "LEONARDO/BEST DIFF TITLE 4 ARTICLE(D)"
  R011L12C = "LEONARDO/AUTHORS OPINION OF LEONARDO(2)"
  R011R01M = "RIVER/MAIN PURPOSE OF TRAIL DESCRIPT.(D)"
  R011R02M = "RIVER/MAIN PURPOSE OF BACK(B)"
  R011R03M = "RIVER/START OF TRAIL(C)"
  R011R04C = "RIVER/ORDER OF PLACES ON TRAIL(1)"
  R011R05C = "RIVER/COST FOR 10 YEAR OLD/FULL DAY(1)"
  R011R06C = "RIVER/EQUIPMENT FOR CHILDREN(2)"
  R011R07C = "RIVER/INFO ABOUT BIKES GOOD CONDITION(1)"
  R011R08C = "RIVER/BIKES FAMILY WOULD NEED(2)"
  R011R09C = "RIVER/PLACES FAMILY COULD VISIT(2)"
  R011R10C = "RIVER/MATCH UP CHILDRENS COMMENTS 2 LOC.(3)"
  R011R11C = "RIVER/MATCH UP QUESTIONS TO PLACES(3)"
  R011H01M = "HARE/HARES GREATEST WORRY(C)"
  R011H02M = "HARE/WHAT MADE THE WHOLE EARTH SHAKE(B)"
  R011H03C = "HARE/WORDS 4 QUICKLY HAPPENED THINGS(2)"
  R011H04C = "HARE/PLACE LION WANTED HARE TAKG HIM(1)"
  R011H05M = "HARE/LION DROPPED THE FRUIT(C)"
  R011H06M = "HARE/HARES FEELG AFTER DROPPG FRUIT(C)"
  R011H07C = "HARE/HOW LION TRIED HARE FEEL BETTER(2)"
  R011H08C = "HARE/WHETHER LION LIKED HARE(1)"
  R011H09C = "HARE/HOW HARES FEELINGS CHANGED(2)"
  R011H10C = "HARE/HOW LION AND HARE ARE DIFFERENT(3)"
  R011H11M = "HARE/MAIN MESSAGE OF THE STORY(B)"
  R011N01M = "PUFFLINGS/PUFFINS ARE CLUMSY(D)"
  R011N02M = "PUFFLINGS/PUFFINS SPEND THE WINTER(C)"
  R011N03M = "PUFFLINGS/PUFFINS COME TO THE ISLAND(C)"
  R011N04M = "PUFFLINGS/HALLA KNOWS THEY WILL FLY(B)"
  R011N05M = "PUFFLINGS/WHAT HAPPENS DURING NIGHTS(B)"
  R011N06M = "PUFFLINGS/STOP THEIR LANDG IN VILLAGE(A)"
  R011N07C = "PUFFLINGS/HOW HALLA USES THE TORCH(2)"
  R011N08C = "PUFFLINGS/HALLAS USE CARDBOARD BOXES(2)"
  R011N09M = "PUFFLINGS/DANGER FACED BY PUFFLINGS(D)"
  R011N10C = "PUFFLINGS/WHY IT NEEDS DAYLIGHT(1)"
  R011N11M = "PUFFLINGS/AFTER PUFFINS ARE RELEASED(D)"
  R011N12C = "PUFFLINGS/HALLAS DIFFERENT FEELINGS(2)"
  R011N13C = "PUFFLINGS/WOULD STD LK 2 GO W HALLA(2)"
  ASREARSC = "AVERAGE SCORE ON ALL BLOCK (150,10)"
  ASINFRSC = "AVERAGE SCORE ON INFORMATION BLOCKS"
  ASLITRSC = "AVERAGE SCORE ON LITERARY BLOCKS"
  ASANRSC  = "BLOCK A SCORE (150,10)"
  ASASCPT  = "RAW SCORE ON BLOCK A ITEMS"
  ASASTDR  = "STANDARDIZED BLOCK A SCORE (50,10)"
  ASCNRSC  = "BLOCK C SCORE (150,10)"
  ASCSCPT  = "RAW SCORE ON BLOCK C ITEM"
  ASCSTDR  = "STANDARDIZED BLOCK C SCORE (50,10)"
  ASFNRSC  = "BLOCK F SCORE (150,10)"
  ASFSCPT  = "RAW SCORE ON BLOCK F ITEMS"
  ASFSTDR  = "STANDARDIZED BLOCK F SCORE (50,10)"
  ASHNRSC  = "BLOCK H SCORE (150,10)"
  ASHSCPT  = "RAW SCORE ON BLOCK H ITEMS"
  ASHSTDR  = "STANDARDIZED BLOCK H SCORE (50,10)"
  ASLNRSC  = "BLOCK L SCORE (150,10)"
  ASLSCPT  = "RAW SCORE ON BLOCK L ITEMS"
  ASLSTDR  = "STANDARDIZED BLOCK L SCORE (50,10)"
  ASMNRSC  = "BLOCK M SCORE (150,10)"
  ASMSCPT  = "RAW SCORE ON BLOCK M ITEMS"
  ASMSTDR  = "STANDARDIZED BLOCK M SCORE (50,10)"
  ASNNRSC  = "BLOCK N SCORE (150,10)"
  ASNSCPT  = "RAW SCORE ON BLOCK N ITEMS"
  ASNSTDR  = "STANDARDIZED BLOCK N SCORE (50,10)"
  ASRNRSC  = "BLOCK R SCORE (150,10)"
  ASRSCPT  = "RAW SCORE ON BLOCK R ITEMS"
  ASRSTDR  = "STANDARDIZED BLOCK R SCORE (50,10)"
  ITPART   = "FINAL PARTICIPATION INDICATOR"
  DPCDATE  = "DATE OF CREATION AT DPC"
  HOUWGT   = "HOUSE WEIGHT"
  TOTWGT   = "TOTAL STUDENT WEIGHT"
  SENWGT   = "SENATE WEIGHT"
  JKZONE   = "JACKKNIFE ZONE"
  JKREP    = "JACKKNIFE REPLICATE CODE"
  IDSTRATE = "EXPLICIT STRATUM"
  IDSTRATI = "IMPLICIT STRATUM"
  ASRINF01 = "PLAUSIBLE VALUE: INFORMATION BLOCKS PV1"
  ASRINF02 = "PLAUSIBLE VALUE: INFORMATION BLOCKS PV2"
  ASRINF03 = "PLAUSIBLE VALUE: INFORMATION BLOCKS PV3"
  ASRINF04 = "PLAUSIBLE VALUE: INFORMATION BLOCKS PV4"
  ASRINF05 = "PLAUSIBLE VALUE: INFORMATION BLOCKS PV5"
  ASRLIT01 = "PLAUSIBLE VALUE: LITERARY BLOCKS PV1"
  ASRLIT02 = "PLAUSIBLE VALUE: LITERARY BLOCKS PV2"
  ASRLIT03 = "PLAUSIBLE VALUE: LITERARY BLOCKS PV3"
  ASRLIT04 = "PLAUSIBLE VALUE: LITERARY BLOCKS PV4"
  ASRLIT05 = "PLAUSIBLE VALUE: LITERARY BLOCKS PV5"
  ASRREA01 = "PLAUSIBLE VALUE: ALL BLOCKS PV1"
  ASRREA02 = "PLAUSIBLE VALUE: ALL BLOCKS PV2"
  ASRREA03 = "PLAUSIBLE VALUE: ALL BLOCKS PV3"
  ASRREA04 = "PLAUSIBLE VALUE: ALL BLOCKS PV4"
  ASRREA05 = "PLAUSIBLE VALUE: ALL BLOCKS PV5"
;

%PUT INFO: recode "not administered" data to missing code ".A" ;
*NOTE: If a CHECK variable is coded correctly with a BLANK, it will be recoded
       to "1", otherwise it will be recoded to "0" ;

IF ITLANG   = 8                THEN ITLANG   = .A ;
IF IDPOP    = 8                THEN IDPOP    = .A ;
IF IDGRADER = 8                THEN IDGRADER = .A ;
IF INPRL01  = 8                THEN INPRL01  = .A ;
IF R011M01M = 8                THEN R011M01M = .A ;
IF R011M02M = 8                THEN R011M02M = .A ;
IF R011M03M = 8                THEN R011M03M = .A ;
IF R011M04C = 8                THEN R011M04C = .A ;
IF R011M05M = 8                THEN R011M05M = .A ;
IF R011M06C = 8                THEN R011M06C = .A ;
IF R011M07C = 8                THEN R011M07C = .A ;
IF R011M08M = 8                THEN R011M08M = .A ;
IF R011M09M = 8                THEN R011M09M = .A ;
IF R011M10C = 8                THEN R011M10C = .A ;
IF R011M11C = 8                THEN R011M11C = .A ;
IF R011M12C = 8                THEN R011M12C = .A ;
IF R011M13M = 8                THEN R011M13M = .A ;
IF R011M14C = 8                THEN R011M14C = .A ;
IF R011C01C = 8                THEN R011C01C = .A ;
IF R011C02C = 8                THEN R011C02C = .A ;
IF R011C03C = 8                THEN R011C03C = .A ;
IF R011C04M = 8                THEN R011C04M = .A ;
IF R011C05M = 8                THEN R011C05M = .A ;
IF R011C06C = 8                THEN R011C06C = .A ;
IF R011C07M = 8                THEN R011C07M = .A ;
IF R011C08C = 8                THEN R011C08C = .A ;
IF R011C09M = 8                THEN R011C09M = .A ;
IF R011C10C = 8                THEN R011C10C = .A ;
IF R011C11C = 8                THEN R011C11C = .A ;
IF R011C12M = 8                THEN R011C12M = .A ;
IF R011C13M = 8                THEN R011C13M = .A ;
IF R011F01M = 8                THEN R011F01M = .A ;
IF R011F02M = 8                THEN R011F02M = .A ;
IF R011F03M = 8                THEN R011F03M = .A ;
IF R011F04M = 8                THEN R011F04M = .A ;
IF R011F05M = 8                THEN R011F05M = .A ;
IF R011F06C = 8                THEN R011F06C = .A ;
IF R011F07C = 8                THEN R011F07C = .A ;
IF R011F08C = 8                THEN R011F08C = .A ;
IF R011F09C = 8                THEN R011F09C = .A ;
IF R011F10C = 8                THEN R011F10C = .A ;
IF R011F11M = 8                THEN R011F11M = .A ;
IF R011F12C = 8                THEN R011F12C = .A ;
IF R011F13M = 8                THEN R011F13M = .A ;
IF R011A01C = 8                THEN R011A01C = .A ;
IF R011A02M = 8                THEN R011A02M = .A ;
IF R011A03C = 8                THEN R011A03C = .A ;
IF R011A04C = 8                THEN R011A04C = .A ;
IF R011A05M = 8                THEN R011A05M = .A ;
IF R011A06M = 8                THEN R011A06M = .A ;
IF R011A07C = 8                THEN R011A07C = .A ;
IF R011A08C = 8                THEN R011A08C = .A ;
IF R011A09C = 8                THEN R011A09C = .A ;
IF R011A10M = 8                THEN R011A10M = .A ;
IF R011A11C = 8                THEN R011A11C = .A ;
IF R011L01M = 8                THEN R011L01M = .A ;
IF R011L02M = 8                THEN R011L02M = .A ;
IF R011L03C = 8                THEN R011L03C = .A ;
IF R011L04C = 8                THEN R011L04C = .A ;
IF R011L05M = 8                THEN R011L05M = .A ;
IF R011L06C = 8                THEN R011L06C = .A ;
IF R011L07M = 8                THEN R011L07M = .A ;
IF R011L08C = 8                THEN R011L08C = .A ;
IF R011L09M = 8                THEN R011L09M = .A ;
IF R011L10C = 8                THEN R011L10C = .A ;
IF R011L11M = 8                THEN R011L11M = .A ;
IF R011L12C = 8                THEN R011L12C = .A ;
IF R011R01M = 8                THEN R011R01M = .A ;
IF R011R02M = 8                THEN R011R02M = .A ;
IF R011R03M = 8                THEN R011R03M = .A ;
IF R011R04C = 8                THEN R011R04C = .A ;
IF R011R05C = 8                THEN R011R05C = .A ;
IF R011R06C = 8                THEN R011R06C = .A ;
IF R011R07C = 8                THEN R011R07C = .A ;
IF R011R08C = 8                THEN R011R08C = .A ;
IF R011R09C = 8                THEN R011R09C = .A ;
IF R011R10C = 8                THEN R011R10C = .A ;
IF R011R11C = 8                THEN R011R11C = .A ;
IF R011H01M = 8                THEN R011H01M = .A ;
IF R011H02M = 8                THEN R011H02M = .A ;
IF R011H03C = 8                THEN R011H03C = .A ;
IF R011H04C = 8                THEN R011H04C = .A ;
IF R011H05M = 8                THEN R011H05M = .A ;
IF R011H06M = 8                THEN R011H06M = .A ;
IF R011H07C = 8                THEN R011H07C = .A ;
IF R011H08C = 8                THEN R011H08C = .A ;
IF R011H09C = 8                THEN R011H09C = .A ;
IF R011H10C = 8                THEN R011H10C = .A ;
IF R011H11M = 8                THEN R011H11M = .A ;
IF R011N01M = 8                THEN R011N01M = .A ;
IF R011N02M = 8                THEN R011N02M = .A ;
IF R011N03M = 8                THEN R011N03M = .A ;
IF R011N04M = 8                THEN R011N04M = .A ;
IF R011N05M = 8                THEN R011N05M = .A ;
IF R011N06M = 8                THEN R011N06M = .A ;
IF R011N07C = 8                THEN R011N07C = .A ;
IF R011N08C = 8                THEN R011N08C = .A ;
IF R011N09M = 8                THEN R011N09M = .A ;
IF R011N10C = 8                THEN R011N10C = .A ;
IF R011N11M = 8                THEN R011N11M = .A ;
IF R011N12C = 8                THEN R011N12C = .A ;
IF R011N13C = 8                THEN R011N13C = .A ;
IF ASREARSC = 9998             THEN ASREARSC = .A ;
IF ASINFRSC = 9998             THEN ASINFRSC = .A ;
IF ASLITRSC = 9998             THEN ASLITRSC = .A ;
IF ASANRSC  = 9998             THEN ASANRSC  = .A ;
IF ASASCPT  = 9998             THEN ASASCPT  = .A ;
IF ASASTDR  = 9998             THEN ASASTDR  = .A ;
IF ASCNRSC  = 9998             THEN ASCNRSC  = .A ;
IF ASCSCPT  = 9998             THEN ASCSCPT  = .A ;
IF ASCSTDR  = 9998             THEN ASCSTDR  = .A ;
IF ASFNRSC  = 9998             THEN ASFNRSC  = .A ;
IF ASFSCPT  = 9998             THEN ASFSCPT  = .A ;
IF ASFSTDR  = 9998             THEN ASFSTDR  = .A ;
IF ASHNRSC  = 9998             THEN ASHNRSC  = .A ;
IF ASHSCPT  = 9998             THEN ASHSCPT  = .A ;
IF ASHSTDR  = 9998             THEN ASHSTDR  = .A ;
IF ASLNRSC  = 9998             THEN ASLNRSC  = .A ;
IF ASLSCPT  = 9998             THEN ASLSCPT  = .A ;
IF ASLSTDR  = 9998             THEN ASLSTDR  = .A ;
IF ASMNRSC  = 9998             THEN ASMNRSC  = .A ;
IF ASMSCPT  = 9998             THEN ASMSCPT  = .A ;
IF ASMSTDR  = 9998             THEN ASMSTDR  = .A ;
IF ASNNRSC  = 9998             THEN ASNNRSC  = .A ;
IF ASNSCPT  = 9998             THEN ASNSCPT  = .A ;
IF ASNSTDR  = 9998             THEN ASNSTDR  = .A ;
IF ASRNRSC  = 9998             THEN ASRNRSC  = .A ;
IF ASRSCPT  = 9998             THEN ASRSCPT  = .A ;
IF ASRSTDR  = 9998             THEN ASRSTDR  = .A ;
IF ITPART   = 8                THEN ITPART   = .A ;
IF HOUWGT   = 999998           THEN HOUWGT   = .A ;
IF TOTWGT   = 999998           THEN TOTWGT   = .A ;
IF SENWGT   = 999998           THEN SENWGT   = .A ;
IF JKZONE   = 98               THEN JKZONE   = .A ;
IF JKREP    = 8                THEN JKREP    = .A ;
IF IDSTRATE = 998              THEN IDSTRATE = .A ;
IF IDSTRATI = 998              THEN IDSTRATI = .A ;
IF ASRINF01 = 999998           THEN ASRINF01 = .A ;
IF ASRINF02 = 999998           THEN ASRINF02 = .A ;
IF ASRINF03 = 999998           THEN ASRINF03 = .A ;
IF ASRINF04 = 999998           THEN ASRINF04 = .A ;
IF ASRINF05 = 999998           THEN ASRINF05 = .A ;
IF ASRLIT01 = 999998           THEN ASRLIT01 = .A ;
IF ASRLIT02 = 999998           THEN ASRLIT02 = .A ;
IF ASRLIT03 = 999998           THEN ASRLIT03 = .A ;
IF ASRLIT04 = 999998           THEN ASRLIT04 = .A ;
IF ASRLIT05 = 999998           THEN ASRLIT05 = .A ;
IF ASRREA01 = 999998           THEN ASRREA01 = .A ;
IF ASRREA02 = 999998           THEN ASRREA02 = .A ;
IF ASRREA03 = 999998           THEN ASRREA03 = .A ;
IF ASRREA04 = 999998           THEN ASRREA04 = .A ;
IF ASRREA05 = 999998           THEN ASRREA05 = .A ;

%PUT INFO: recode special missing codes to SAS missing codes ;
*NOTE: Special missing codes are recoded to SAS
       character - missing codes;

IF R011M01M = 6                THEN R011M01M = .R ;
IF R011M01M = 7                THEN R011M01M = .I ;
IF R011M02M = 6                THEN R011M02M = .R ;
IF R011M02M = 7                THEN R011M02M = .I ;
IF R011M03M = 6                THEN R011M03M = .R ;
IF R011M03M = 7                THEN R011M03M = .I ;
IF R011M04C = 6                THEN R011M04C = .R ;
IF R011M04C = 7                THEN R011M04C = .I ;
IF R011M05M = 6                THEN R011M05M = .R ;
IF R011M05M = 7                THEN R011M05M = .I ;
IF R011M06C = 6                THEN R011M06C = .R ;
IF R011M06C = 7                THEN R011M06C = .I ;
IF R011M07C = 6                THEN R011M07C = .R ;
IF R011M07C = 7                THEN R011M07C = .I ;
IF R011M08M = 6                THEN R011M08M = .R ;
IF R011M08M = 7                THEN R011M08M = .I ;
IF R011M09M = 6                THEN R011M09M = .R ;
IF R011M09M = 7                THEN R011M09M = .I ;
IF R011M10C = 6                THEN R011M10C = .R ;
IF R011M10C = 7                THEN R011M10C = .I ;
IF R011M11C = 6                THEN R011M11C = .R ;
IF R011M11C = 7                THEN R011M11C = .I ;
IF R011M12C = 6                THEN R011M12C = .R ;
IF R011M12C = 7                THEN R011M12C = .I ;
IF R011M13M = 6                THEN R011M13M = .R ;
IF R011M13M = 7                THEN R011M13M = .I ;
IF R011M14C = 6                THEN R011M14C = .R ;
IF R011M14C = 7                THEN R011M14C = .I ;
IF R011C01C = 6                THEN R011C01C = .R ;
IF R011C01C = 7                THEN R011C01C = .I ;
IF R011C02C = 6                THEN R011C02C = .R ;
IF R011C02C = 7                THEN R011C02C = .I ;
IF R011C03C = 6                THEN R011C03C = .R ;
IF R011C03C = 7                THEN R011C03C = .I ;
IF R011C04M = 6                THEN R011C04M = .R ;
IF R011C04M = 7                THEN R011C04M = .I ;
IF R011C05M = 6                THEN R011C05M = .R ;
IF R011C05M = 7                THEN R011C05M = .I ;
IF R011C06C = 6                THEN R011C06C = .R ;
IF R011C06C = 7                THEN R011C06C = .I ;
IF R011C07M = 6                THEN R011C07M = .R ;
IF R011C07M = 7                THEN R011C07M = .I ;
IF R011C08C = 6                THEN R011C08C = .R ;
IF R011C08C = 7                THEN R011C08C = .I ;
IF R011C09M = 6                THEN R011C09M = .R ;
IF R011C09M = 7                THEN R011C09M = .I ;
IF R011C10C = 6                THEN R011C10C = .R ;
IF R011C10C = 7                THEN R011C10C = .I ;
IF R011C11C = 6                THEN R011C11C = .R ;
IF R011C11C = 7                THEN R011C11C = .I ;
IF R011C12M = 6                THEN R011C12M = .R ;
IF R011C12M = 7                THEN R011C12M = .I ;
IF R011C13M = 6                THEN R011C13M = .R ;
IF R011C13M = 7                THEN R011C13M = .I ;
IF R011F01M = 6                THEN R011F01M = .R ;
IF R011F01M = 7                THEN R011F01M = .I ;
IF R011F02M = 6                THEN R011F02M = .R ;
IF R011F02M = 7                THEN R011F02M = .I ;
IF R011F03M = 6                THEN R011F03M = .R ;
IF R011F03M = 7                THEN R011F03M = .I ;
IF R011F04M = 6                THEN R011F04M = .R ;
IF R011F04M = 7                THEN R011F04M = .I ;
IF R011F05M = 6                THEN R011F05M = .R ;
IF R011F05M = 7                THEN R011F05M = .I ;
IF R011F06C = 6                THEN R011F06C = .R ;
IF R011F06C = 7                THEN R011F06C = .I ;
IF R011F07C = 6                THEN R011F07C = .R ;
IF R011F07C = 7                THEN R011F07C = .I ;
IF R011F08C = 6                THEN R011F08C = .R ;
IF R011F08C = 7                THEN R011F08C = .I ;
IF R011F09C = 6                THEN R011F09C = .R ;
IF R011F09C = 7                THEN R011F09C = .I ;
IF R011F10C = 6                THEN R011F10C = .R ;
IF R011F10C = 7                THEN R011F10C = .I ;
IF R011F11M = 6                THEN R011F11M = .R ;
IF R011F11M = 7                THEN R011F11M = .I ;
IF R011F12C = 6                THEN R011F12C = .R ;
IF R011F12C = 7                THEN R011F12C = .I ;
IF R011F13M = 6                THEN R011F13M = .R ;
IF R011F13M = 7                THEN R011F13M = .I ;
IF R011A01C = 6                THEN R011A01C = .R ;
IF R011A01C = 7                THEN R011A01C = .I ;
IF R011A02M = 6                THEN R011A02M = .R ;
IF R011A02M = 7                THEN R011A02M = .I ;
IF R011A03C = 6                THEN R011A03C = .R ;
IF R011A03C = 7                THEN R011A03C = .I ;
IF R011A04C = 6                THEN R011A04C = .R ;
IF R011A04C = 7                THEN R011A04C = .I ;
IF R011A05M = 6                THEN R011A05M = .R ;
IF R011A05M = 7                THEN R011A05M = .I ;
IF R011A06M = 6                THEN R011A06M = .R ;
IF R011A06M = 7                THEN R011A06M = .I ;
IF R011A07C = 6                THEN R011A07C = .R ;
IF R011A07C = 7                THEN R011A07C = .I ;
IF R011A08C = 6                THEN R011A08C = .R ;
IF R011A08C = 7                THEN R011A08C = .I ;
IF R011A09C = 6                THEN R011A09C = .R ;
IF R011A09C = 7                THEN R011A09C = .I ;
IF R011A10M = 6                THEN R011A10M = .R ;
IF R011A10M = 7                THEN R011A10M = .I ;
IF R011A11C = 6                THEN R011A11C = .R ;
IF R011A11C = 7                THEN R011A11C = .I ;
IF R011L01M = 6                THEN R011L01M = .R ;
IF R011L01M = 7                THEN R011L01M = .I ;
IF R011L02M = 6                THEN R011L02M = .R ;
IF R011L02M = 7                THEN R011L02M = .I ;
IF R011L03C = 6                THEN R011L03C = .R ;
IF R011L03C = 7                THEN R011L03C = .I ;
IF R011L04C = 6                THEN R011L04C = .R ;
IF R011L04C = 7                THEN R011L04C = .I ;
IF R011L05M = 6                THEN R011L05M = .R ;
IF R011L05M = 7                THEN R011L05M = .I ;
IF R011L06C = 6                THEN R011L06C = .R ;
IF R011L06C = 7                THEN R011L06C = .I ;
IF R011L07M = 6                THEN R011L07M = .R ;
IF R011L07M = 7                THEN R011L07M = .I ;
IF R011L08C = 6                THEN R011L08C = .R ;
IF R011L08C = 7                THEN R011L08C = .I ;
IF R011L09M = 6                THEN R011L09M = .R ;
IF R011L09M = 7                THEN R011L09M = .I ;
IF R011L10C = 6                THEN R011L10C = .R ;
IF R011L10C = 7                THEN R011L10C = .I ;
IF R011L11M = 6                THEN R011L11M = .R ;
IF R011L11M = 7                THEN R011L11M = .I ;
IF R011L12C = 6                THEN R011L12C = .R ;
IF R011L12C = 7                THEN R011L12C = .I ;
IF R011R01M = 6                THEN R011R01M = .R ;
IF R011R01M = 7                THEN R011R01M = .I ;
IF R011R02M = 6                THEN R011R02M = .R ;
IF R011R02M = 7                THEN R011R02M = .I ;
IF R011R03M = 6                THEN R011R03M = .R ;
IF R011R03M = 7                THEN R011R03M = .I ;
IF R011R04C = 6                THEN R011R04C = .R ;
IF R011R04C = 7                THEN R011R04C = .I ;
IF R011R05C = 6                THEN R011R05C = .R ;
IF R011R05C = 7                THEN R011R05C = .I ;
IF R011R06C = 6                THEN R011R06C = .R ;
IF R011R06C = 7                THEN R011R06C = .I ;
IF R011R07C = 6                THEN R011R07C = .R ;
IF R011R07C = 7                THEN R011R07C = .I ;
IF R011R08C = 6                THEN R011R08C = .R ;
IF R011R08C = 7                THEN R011R08C = .I ;
IF R011R09C = 6                THEN R011R09C = .R ;
IF R011R09C = 7                THEN R011R09C = .I ;
IF R011R10C = 6                THEN R011R10C = .R ;
IF R011R10C = 7                THEN R011R10C = .I ;
IF R011R11C = 6                THEN R011R11C = .R ;
IF R011R11C = 7                THEN R011R11C = .I ;
IF R011H01M = 6                THEN R011H01M = .R ;
IF R011H01M = 7                THEN R011H01M = .I ;
IF R011H02M = 6                THEN R011H02M = .R ;
IF R011H02M = 7                THEN R011H02M = .I ;
IF R011H03C = 6                THEN R011H03C = .R ;
IF R011H03C = 7                THEN R011H03C = .I ;
IF R011H04C = 6                THEN R011H04C = .R ;
IF R011H04C = 7                THEN R011H04C = .I ;
IF R011H05M = 6                THEN R011H05M = .R ;
IF R011H05M = 7                THEN R011H05M = .I ;
IF R011H06M = 6                THEN R011H06M = .R ;
IF R011H06M = 7                THEN R011H06M = .I ;
IF R011H07C = 6                THEN R011H07C = .R ;
IF R011H07C = 7                THEN R011H07C = .I ;
IF R011H08C = 6                THEN R011H08C = .R ;
IF R011H08C = 7                THEN R011H08C = .I ;
IF R011H09C = 6                THEN R011H09C = .R ;
IF R011H09C = 7                THEN R011H09C = .I ;
IF R011H10C = 6                THEN R011H10C = .R ;
IF R011H10C = 7                THEN R011H10C = .I ;
IF R011H11M = 6                THEN R011H11M = .R ;
IF R011H11M = 7                THEN R011H11M = .I ;
IF R011N01M = 6                THEN R011N01M = .R ;
IF R011N01M = 7                THEN R011N01M = .I ;
IF R011N02M = 6                THEN R011N02M = .R ;
IF R011N02M = 7                THEN R011N02M = .I ;
IF R011N03M = 6                THEN R011N03M = .R ;
IF R011N03M = 7                THEN R011N03M = .I ;
IF R011N04M = 6                THEN R011N04M = .R ;
IF R011N04M = 7                THEN R011N04M = .I ;
IF R011N05M = 6                THEN R011N05M = .R ;
IF R011N05M = 7                THEN R011N05M = .I ;
IF R011N06M = 6                THEN R011N06M = .R ;
IF R011N06M = 7                THEN R011N06M = .I ;
IF R011N07C = 6                THEN R011N07C = .R ;
IF R011N07C = 7                THEN R011N07C = .I ;
IF R011N08C = 6                THEN R011N08C = .R ;
IF R011N08C = 7                THEN R011N08C = .I ;
IF R011N09M = 6                THEN R011N09M = .R ;
IF R011N09M = 7                THEN R011N09M = .I ;
IF R011N10C = 6                THEN R011N10C = .R ;
IF R011N10C = 7                THEN R011N10C = .I ;
IF R011N11M = 6                THEN R011N11M = .R ;
IF R011N11M = 7                THEN R011N11M = .I ;
IF R011N12C = 6                THEN R011N12C = .R ;
IF R011N12C = 7                THEN R011N12C = .I ;
IF R011N13C = 6                THEN R011N13C = .R ;
IF R011N13C = 7                THEN R011N13C = .I ;

%PUT INFO: recode omitted data to missing code "." ;
*NOTE: BLANKS are recoded to SYSMIS by SAS ;

IF IDBOOK   = 99               THEN IDBOOK   = . ;
IF ITLANG   = 9                THEN ITLANG   = . ;
IF IDPOP    = 9                THEN IDPOP    = . ;
IF IDGRADER = 9                THEN IDGRADER = . ;
IF INPRL01  = 9                THEN INPRL01  = . ;
IF R011M01M = 9                THEN R011M01M = . ;
IF R011M02M = 9                THEN R011M02M = . ;
IF R011M03M = 9                THEN R011M03M = . ;
IF R011M04C = 9                THEN R011M04C = . ;
IF R011M05M = 9                THEN R011M05M = . ;
IF R011M06C = 9                THEN R011M06C = . ;
IF R011M07C = 9                THEN R011M07C = . ;
IF R011M08M = 9                THEN R011M08M = . ;
IF R011M09M = 9                THEN R011M09M = . ;
IF R011M10C = 9                THEN R011M10C = . ;
IF R011M11C = 9                THEN R011M11C = . ;
IF R011M12C = 9                THEN R011M12C = . ;
IF R011M13M = 9                THEN R011M13M = . ;
IF R011M14C = 9                THEN R011M14C = . ;
IF R011C01C = 9                THEN R011C01C = . ;
IF R011C02C = 9                THEN R011C02C = . ;
IF R011C03C = 9                THEN R011C03C = . ;
IF R011C04M = 9                THEN R011C04M = . ;
IF R011C05M = 9                THEN R011C05M = . ;
IF R011C06C = 9                THEN R011C06C = . ;
IF R011C07M = 9                THEN R011C07M = . ;
IF R011C08C = 9                THEN R011C08C = . ;
IF R011C09M = 9                THEN R011C09M = . ;
IF R011C10C = 9                THEN R011C10C = . ;
IF R011C11C = 9                THEN R011C11C = . ;
IF R011C12M = 9                THEN R011C12M = . ;
IF R011C13M = 9                THEN R011C13M = . ;
IF R011F01M = 9                THEN R011F01M = . ;
IF R011F02M = 9                THEN R011F02M = . ;
IF R011F03M = 9                THEN R011F03M = . ;
IF R011F04M = 9                THEN R011F04M = . ;
IF R011F05M = 9                THEN R011F05M = . ;
IF R011F06C = 9                THEN R011F06C = . ;
IF R011F07C = 9                THEN R011F07C = . ;
IF R011F08C = 9                THEN R011F08C = . ;
IF R011F09C = 9                THEN R011F09C = . ;
IF R011F10C = 9                THEN R011F10C = . ;
IF R011F11M = 9                THEN R011F11M = . ;
IF R011F12C = 9                THEN R011F12C = . ;
IF R011F13M = 9                THEN R011F13M = . ;
IF R011A01C = 9                THEN R011A01C = . ;
IF R011A02M = 9                THEN R011A02M = . ;
IF R011A03C = 9                THEN R011A03C = . ;
IF R011A04C = 9                THEN R011A04C = . ;
IF R011A05M = 9                THEN R011A05M = . ;
IF R011A06M = 9                THEN R011A06M = . ;
IF R011A07C = 9                THEN R011A07C = . ;
IF R011A08C = 9                THEN R011A08C = . ;
IF R011A09C = 9                THEN R011A09C = . ;
IF R011A10M = 9                THEN R011A10M = . ;
IF R011A11C = 9                THEN R011A11C = . ;
IF R011L01M = 9                THEN R011L01M = . ;
IF R011L02M = 9                THEN R011L02M = . ;
IF R011L03C = 9                THEN R011L03C = . ;
IF R011L04C = 9                THEN R011L04C = . ;
IF R011L05M = 9                THEN R011L05M = . ;
IF R011L06C = 9                THEN R011L06C = . ;
IF R011L07M = 9                THEN R011L07M = . ;
IF R011L08C = 9                THEN R011L08C = . ;
IF R011L09M = 9                THEN R011L09M = . ;
IF R011L10C = 9                THEN R011L10C = . ;
IF R011L11M = 9                THEN R011L11M = . ;
IF R011L12C = 9                THEN R011L12C = . ;
IF R011R01M = 9                THEN R011R01M = . ;
IF R011R02M = 9                THEN R011R02M = . ;
IF R011R03M = 9                THEN R011R03M = . ;
IF R011R04C = 9                THEN R011R04C = . ;
IF R011R05C = 9                THEN R011R05C = . ;
IF R011R06C = 9                THEN R011R06C = . ;
IF R011R07C = 9                THEN R011R07C = . ;
IF R011R08C = 9                THEN R011R08C = . ;
IF R011R09C = 9                THEN R011R09C = . ;
IF R011R10C = 9                THEN R011R10C = . ;
IF R011R11C = 9                THEN R011R11C = . ;
IF R011H01M = 9                THEN R011H01M = . ;
IF R011H02M = 9                THEN R011H02M = . ;
IF R011H03C = 9                THEN R011H03C = . ;
IF R011H04C = 9                THEN R011H04C = . ;
IF R011H05M = 9                THEN R011H05M = . ;
IF R011H06M = 9                THEN R011H06M = . ;
IF R011H07C = 9                THEN R011H07C = . ;
IF R011H08C = 9                THEN R011H08C = . ;
IF R011H09C = 9                THEN R011H09C = . ;
IF R011H10C = 9                THEN R011H10C = . ;
IF R011H11M = 9                THEN R011H11M = . ;
IF R011N01M = 9                THEN R011N01M = . ;
IF R011N02M = 9                THEN R011N02M = . ;
IF R011N03M = 9                THEN R011N03M = . ;
IF R011N04M = 9                THEN R011N04M = . ;
IF R011N05M = 9                THEN R011N05M = . ;
IF R011N06M = 9                THEN R011N06M = . ;
IF R011N07C = 9                THEN R011N07C = . ;
IF R011N08C = 9                THEN R011N08C = . ;
IF R011N09M = 9                THEN R011N09M = . ;
IF R011N10C = 9                THEN R011N10C = . ;
IF R011N11M = 9                THEN R011N11M = . ;
IF R011N12C = 9                THEN R011N12C = . ;
IF R011N13C = 9                THEN R011N13C = . ;
IF ASREARSC = 9999             THEN ASREARSC = . ;
IF ASINFRSC = 9999             THEN ASINFRSC = . ;
IF ASLITRSC = 9999             THEN ASLITRSC = . ;
IF ASANRSC  = 9999             THEN ASANRSC  = . ;
IF ASASCPT  = 9999             THEN ASASCPT  = . ;
IF ASASTDR  = 9999             THEN ASASTDR  = . ;
IF ASCNRSC  = 9999             THEN ASCNRSC  = . ;
IF ASCSCPT  = 9999             THEN ASCSCPT  = . ;
IF ASCSTDR  = 9999             THEN ASCSTDR  = . ;
IF ASFNRSC  = 9999             THEN ASFNRSC  = . ;
IF ASFSCPT  = 9999             THEN ASFSCPT  = . ;
IF ASFSTDR  = 9999             THEN ASFSTDR  = . ;
IF ASHNRSC  = 9999             THEN ASHNRSC  = . ;
IF ASHSCPT  = 9999             THEN ASHSCPT  = . ;
IF ASHSTDR  = 9999             THEN ASHSTDR  = . ;
IF ASLNRSC  = 9999             THEN ASLNRSC  = . ;
IF ASLSCPT  = 9999             THEN ASLSCPT  = . ;
IF ASLSTDR  = 9999             THEN ASLSTDR  = . ;
IF ASMNRSC  = 9999             THEN ASMNRSC  = . ;
IF ASMSCPT  = 9999             THEN ASMSCPT  = . ;
IF ASMSTDR  = 9999             THEN ASMSTDR  = . ;
IF ASNNRSC  = 9999             THEN ASNNRSC  = . ;
IF ASNSCPT  = 9999             THEN ASNSCPT  = . ;
IF ASNSTDR  = 9999             THEN ASNSTDR  = . ;
IF ASRNRSC  = 9999             THEN ASRNRSC  = . ;
IF ASRSCPT  = 9999             THEN ASRSCPT  = . ;
IF ASRSTDR  = 9999             THEN ASRSTDR  = . ;
IF ITPART   = 9                THEN ITPART   = . ;
IF HOUWGT   = 999999           THEN HOUWGT   = . ;
IF TOTWGT   = 999999           THEN TOTWGT   = . ;
IF SENWGT   = 999999           THEN SENWGT   = . ;
IF JKZONE   = 99               THEN JKZONE   = . ;
IF JKREP    = 9                THEN JKREP    = . ;
IF IDSTRATE = 999              THEN IDSTRATE = . ;
IF IDSTRATI = 999              THEN IDSTRATI = . ;
IF ASRINF01 = 999999           THEN ASRINF01 = . ;
IF ASRINF02 = 999999           THEN ASRINF02 = . ;
IF ASRINF03 = 999999           THEN ASRINF03 = . ;
IF ASRINF04 = 999999           THEN ASRINF04 = . ;
IF ASRINF05 = 999999           THEN ASRINF05 = . ;
IF ASRLIT01 = 999999           THEN ASRLIT01 = . ;
IF ASRLIT02 = 999999           THEN ASRLIT02 = . ;
IF ASRLIT03 = 999999           THEN ASRLIT03 = . ;
IF ASRLIT04 = 999999           THEN ASRLIT04 = . ;
IF ASRLIT05 = 999999           THEN ASRLIT05 = . ;
IF ASRREA01 = 999999           THEN ASRREA01 = . ;
IF ASRREA02 = 999999           THEN ASRREA02 = . ;
IF ASRREA03 = 999999           THEN ASRREA03 = . ;
IF ASRREA04 = 999999           THEN ASRREA04 = . ;
IF ASRREA05 = 999999           THEN ASRREA05 = . ;

%PUT INFO: assign variable labels to recoded variables ;
LABEL
;

proc sort ; by idcntry idstud;

       %let i = %eval(&i + 1);
     %end;
run;
%mend doit;

%doit;












