%let cty = ARG BGR BLZ CAN COL CYP CZE DEU ENG FRA
           GRC HKG HUN IRN ISL ISR ITA KWT LTU LVA
           MAR MDA MKD NLD NOR NZL ROM RUS SCO SGP
           SVK SVN SWE TUR USA SE3;

Options nosource nocenter;

LIBNAME libdat  "c:\pirls\Data" ;
LIBNAME library "c:\pirls\Data" ;

%macro doit;
  %let i = 1;
     %do %while(%length(%scan(&cty,&i)));
       %let ccode = %lowcase(%scan(&cty,&i));

%let fname= asg&ccode.r1 ;

FILENAME rawinp "c:\pirls\Data\&fname..dat" ;

%PUT INFO: data set definition ;
%PUT INFO: data set definitions have to be modified ;

*Output data set ;
data libdat.&fname;

*NOTE: LRECL may need to be modified ;
INFILE rawinp LRECL=1250 END=eof LENGTH=lnline LINE=ln MISSOVER ;

%PUT INFO: shorten variable definitions to save secondary storage area ;
%PUT INFO: refer to the SAS manual for an appropriate length for variables ;

*NOTE: The LENGTH statement in a data step specifies the number of bytes, the
       SAS - sytem uses for storing values of variables in each data set being created. ;
LENGTH DEFAULT=5 ;
LENGTH      IDCNTRY    5 ;
LENGTH      IDSCHOOL   4 ;
LENGTH      IDCLASS    6 ;
LENGTH      IDGRADE    3 ;
LENGTH      IDSTUD     8 ;
LENGTH      ITBIRTHM   3 ;
LENGTH      ITBIRTHY   3 ;
LENGTH      ITSEX      3 ;
LENGTH      IDBOOK     3 ;
LENGTH      ITADMINI   3 ;
LENGTH      ITDATEM    3 ;
LENGTH      ITDATEY    4 ;
LENGTH      ITLANG     3 ;
LENGTH      IDPOP      3 ;
LENGTH      IDGRADER   3 ;
LENGTH      INPRL01    3 ;
LENGTH      ASBGSEX    3 ;
LENGTH      ASBGBIRM   3 ;
LENGTH      ASBGBIRY   3 ;
LENGTH      ASBGTOC1   3 ;
LENGTH      ASBGTOC2   3 ;
LENGTH      ASBGTOC3   3 ;
LENGTH      ASBGTOC4   3 ;
LENGTH      ASBGTOC5   3 ;
LENGTH      ASBGTOC6   3 ;
LENGTH      ASBGTOC7   3 ;
LENGTH      ASBGROC1   3 ;
LENGTH      ASBGROC2   3 ;
LENGTH      ASBGROC3   3 ;
LENGTH      ASBGROC4   3 ;
LENGTH      ASBGROC5   3 ;
LENGTH      ASBGROC6   3 ;
LENGTH      ASBGROC7   3 ;
LENGTH      ASBGROC8   3 ;
LENGTH      ASBGBLIB   3 ;
LENGTH      ASBGTVDY   3 ;
LENGTH      ASBGTIC1   3 ;
LENGTH      ASBGTIC2   3 ;
LENGTH      ASBGTIC3   3 ;
LENGTH      ASBGTIC4   3 ;
LENGTH      ASBGTIC5   3 ;
LENGTH      ASBGTIC6   3 ;
LENGTH      ASBGAFR1   3 ;
LENGTH      ASBGAFR2   3 ;
LENGTH      ASBGAFR3   3 ;
LENGTH      ASBGAFR4   3 ;
LENGTH      ASBGAFR5   3 ;
LENGTH      ASBGAFR6   3 ;
LENGTH      ASBGAFR7   3 ;
LENGTH      ASBGAFR8   3 ;
LENGTH      ASBGHWRD   3 ;
LENGTH      ASBGHWTM   3 ;
LENGTH      ASBGUSPC   3 ;
LENGTH      ASBGPCU1   3 ;
LENGTH      ASBGPCU2   3 ;
LENGTH      ASBGPCU3   3 ;
LENGTH      ASBGPC1    3 ;
LENGTH      ASBGPC2    3 ;
LENGTH      ASBGPC3    3 ;
LENGTH      ASBGPC4    3 ;
LENGTH      ASBGRST1   3 ;
LENGTH      ASBGRST2   3 ;
LENGTH      ASBGRST3   3 ;
LENGTH      ASBGRST4   3 ;
LENGTH      ASBGRST5   3 ;
LENGTH      ASBGRST6   3 ;
LENGTH      ASBGRAB1   3 ;
LENGTH      ASBGRAB2   3 ;
LENGTH      ASBGRAB3   3 ;
LENGTH      ASBGRAB4   3 ;
LENGTH      ASBGCST1   3 ;
LENGTH      ASBGCST2   3 ;
LENGTH      ASBGCST3   3 ;
LENGTH      ASBGCST4   3 ;
LENGTH      ASBGCST5   3 ;
LENGTH      ASBGSSTL   3 ;
LENGTH      ASBGOSTL   3 ;
LENGTH      ASBGSBUL   3 ;
LENGTH      ASBGOBUL   3 ;
LENGTH      ASBGSHRT   3 ;
LENGTH      ASBGOHRT   3 ;
LENGTH      ASBGLAN1   3 ;
LENGTH      ASBGLAN2   3 ;
LENGTH      ASBGLAN3   3 ;
LENGTH      ASBGLAN4   3 ;
LENGTH      ASBGLAN5   3 ;
LENGTH      ASBGLAN6   3 ;
LENGTH      ASBGLANH   3 ;
LENGTH      ASBGLANA   3 ;
LENGTH      ASBGBOOK   3 ;
LENGTH      ASBGPS1    3 ;
LENGTH      ASBGPS2    3 ;
LENGTH      ASBGPS3    3 ;
LENGTH      ASBGPS4    3 ;
LENGTH      ASBGPS5    3 ;
LENGTH      ASBGPS6    3 ;
LENGTH      ASBGPS7    3 ;
LENGTH      ASBGPS8    3 ;
LENGTH      ASBGPS9    3 ;
LENGTH      ASBGPS10   3 ;
LENGTH      ASBGPS11   3 ;
LENGTH      ASBGPS12   3 ;
LENGTH      ASBGPEOP   3 ;
LENGTH      ASBGCHDH   3 ;
LENGTH      ASBGBRN1   3 ;
LENGTH      ASBGBRN2   3 ;
LENGTH      ASBGBRNM   3 ;
LENGTH      ASBGBRNF   3 ;
LENGTH      ITPART     3 ;
LENGTH      ASDGAGE    8 ;
LENGTH      HOUWGT     8 ;
LENGTH      TOTWGT     8 ;
LENGTH      SENWGT     8 ;
LENGTH      WGTADJ1    8 ;
LENGTH      WGTADJ3    8 ;
LENGTH      WGTFAC1    8 ;
LENGTH      WGTFAC2    8 ;
LENGTH      WGTFAC3    8 ;
LENGTH      JKZONE     3 ;
LENGTH      JKREP      3 ;
LENGTH      DPCDATE    6 ;
LENGTH      IDSTRATE   3 ;
LENGTH      IDSTRATI   3 ;
LENGTH      ASRINF01   8 ;
LENGTH      ASRINF02   8 ;
LENGTH      ASRINF03   8 ;
LENGTH      ASRINF04   8 ;
LENGTH      ASRINF05   8 ;
LENGTH      ASRLIT01   8 ;
LENGTH      ASRLIT02   8 ;
LENGTH      ASRLIT03   8 ;
LENGTH      ASRLIT04   8 ;
LENGTH      ASRLIT05   8 ;
LENGTH      ASRREA01   8 ;
LENGTH      ASRREA02   8 ;
LENGTH      ASRREA03   8 ;
LENGTH      ASRREA04   8 ;
LENGTH      ASRREA05   8 ;
LENGTH      ASDGPS     3 ;
LENGTH      ASDGBRN    3 ;
LENGTH      ASDGSATR   3 ;
LENGTH      ASDGSELF   3 ;
LENGTH      ASDGINFR   3 ;
LENGTH      ASDGTIC    3 ;
LENGTH      ASDGTIC2   3 ;
LENGTH      ASDGAFR    3 ;
LENGTH      ASDGAFR2   3 ;
LENGTH      ASIIBM01   3 ;
LENGTH      ASIIBM02   3 ;
LENGTH      ASIIBM03   3 ;
LENGTH      ASIIBM04   3 ;
LENGTH      ASIIBM05   3 ;
LENGTH      ASINBM01   3 ;
LENGTH      ASINBM02   3 ;
LENGTH      ASINBM03   3 ;
LENGTH      ASINBM04   3 ;
LENGTH      ASINBM05   3 ;
LENGTH      ASLIBM01   3 ;
LENGTH      ASLIBM02   3 ;
LENGTH      ASLIBM03   3 ;
LENGTH      ASLIBM04   3 ;
LENGTH      ASLIBM05   3 ;
LENGTH      ASLNBM01   3 ;
LENGTH      ASLNBM02   3 ;
LENGTH      ASLNBM03   3 ;
LENGTH      ASLNBM04   3 ;
LENGTH      ASLNBM05   3 ;
LENGTH      ASRIBM01   3 ;
LENGTH      ASRIBM02   3 ;
LENGTH      ASRIBM03   3 ;
LENGTH      ASRIBM04   3 ;
LENGTH      ASRIBM05   3 ;
LENGTH      ASRNBM01   3 ;
LENGTH      ASRNBM02   3 ;
LENGTH      ASRNBM03   3 ;
LENGTH      ASRNBM04   3 ;
LENGTH      ASRNBM05   3 ;


%PUT INFO: Missing category A refers to "not administered" values ;
%PUT INFO: Missing category I refers to "invalid" values ;
%PUT INFO: Missing category B refers to "logically not applicable" values ;
%PUT INFO: Missing category R refers to "not reached" items ;
%PUT INFO: Missing category . refers to missing values ;
MISSING A I B R ;

*NOTE: The INPUT statement reads raw data and assigns variable names.
       The positions specified below correspond to the positions of the variables
       in the raw data file. ;

INPUT
  IDCNTRY       1-   5     
  IDSCHOOL      6-   9     
  IDCLASS      10-  15     
  IDGRADE      16-  17     
  IDSTUD       18-  25     
  ITBIRTHM     26-  27     
  ITBIRTHY     28-  29     
  ITSEX        30-  30     
  IDBOOK       31-  32     
  ITADMINI     33-  33     
  ITDATEM      34-  35     
  ITDATEY      36-  39     
  ITLANG       40-  40     
  IDPOP        41-  41     
  IDGRADER     42-  42     
  INPRL01      43-  43     
  ASBGSEX      44-  44     
  ASBGBIRM     45-  46     
  ASBGBIRY     47-  48     
  ASBGTOC1     49-  49     
  ASBGTOC2     50-  50     
  ASBGTOC3     51-  51     
  ASBGTOC4     52-  52     
  ASBGTOC5     53-  53     
  ASBGTOC6     54-  54     
  ASBGTOC7     55-  55     
  ASBGROC1     56-  56     
  ASBGROC2     57-  57     
  ASBGROC3     58-  58     
  ASBGROC4     59-  59     
  ASBGROC5     60-  60     
  ASBGROC6     61-  61     
  ASBGROC7     62-  62     
  ASBGROC8     63-  63     
  ASBGBLIB     64-  64     
  ASBGTVDY     65-  65     
  ASBGTIC1     66-  66     
  ASBGTIC2     67-  67     
  ASBGTIC3     68-  68     
  ASBGTIC4     69-  69     
  ASBGTIC5     70-  70     
  ASBGTIC6     71-  71     
  ASBGAFR1     72-  72     
  ASBGAFR2     73-  73     
  ASBGAFR3     74-  74     
  ASBGAFR4     75-  75     
  ASBGAFR5     76-  76     
  ASBGAFR6     77-  77     
  ASBGAFR7     78-  78     
  ASBGAFR8     79-  79     
  ASBGHWRD     80-  80     
  ASBGHWTM     81-  81     
  ASBGUSPC     82-  82     
  ASBGPCU1     83-  83     
  ASBGPCU2     84-  84     
  ASBGPCU3     85-  85     
  ASBGPC1      86-  86     
  ASBGPC2      87-  87     
  ASBGPC3      88-  88     
  ASBGPC4      89-  89     
  ASBGRST1     90-  90     
  ASBGRST2     91-  91     
  ASBGRST3     92-  92     
  ASBGRST4     93-  93     
  ASBGRST5     94-  94     
  ASBGRST6     95-  95     
  ASBGRAB1     96-  96     
  ASBGRAB2     97-  97     
  ASBGRAB3     98-  98     
  ASBGRAB4     99-  99     
  ASBGCST1    100- 100     
  ASBGCST2    101- 101     
  ASBGCST3    102- 102     
  ASBGCST4    103- 103     
  ASBGCST5    104- 104     
  ASBGSSTL    105- 105     
  ASBGOSTL    106- 106     
  ASBGSBUL    107- 107     
  ASBGOBUL    108- 108     
  ASBGSHRT    109- 109     
  ASBGOHRT    110- 110     
  ASBGLAN1    111- 111     
  ASBGLAN2    112- 112     
  ASBGLAN3    113- 113     
  ASBGLAN4    114- 114     
  ASBGLAN5    115- 115     
  ASBGLAN6    116- 116     
  ASBGLANH    117- 117     
  ASBGLANA    118- 118     
  ASBGBOOK    119- 119     
  ASBGPS1     120- 120     
  ASBGPS2     121- 121     
  ASBGPS3     122- 122     
  ASBGPS4     123- 123     
  ASBGPS5     124- 124     
  ASBGPS6     125- 125     
  ASBGPS7     126- 126     
  ASBGPS8     127- 127     
  ASBGPS9     128- 128     
  ASBGPS10    129- 129     
  ASBGPS11    130- 130     
  ASBGPS12    131- 131     
  ASBGPEOP    132- 133     
  ASBGCHDH    134- 135     
  ASBGBRN1    136- 136     
  ASBGBRN2    137- 138     
  ASBGBRNM    139- 139     
  ASBGBRNF    140- 140     
  ITPART      141- 141     
  ASDGAGE     142- 147 .3
  HOUWGT      148- 160 .6
  TOTWGT      161- 173 .6
  SENWGT      174- 186 .6
  WGTADJ1     187- 199 .6
  WGTADJ3     200- 212 .6
  WGTFAC1     213- 225 .6
  WGTFAC2     226- 238 .6
  WGTFAC3     239- 251 .6
  JKZONE      252- 253     
  JKREP       254- 254     
  DPCDATE     255- 260     
  IDSTRATE    261- 263     
  IDSTRATI    264- 266     
  ASRINF01    267- 279 .6
  ASRINF02    280- 292 .6
  ASRINF03    293- 305 .6
  ASRINF04    306- 318 .6
  ASRINF05    319- 331 .6
  ASRLIT01    332- 344 .6
  ASRLIT02    345- 357 .6
  ASRLIT03    358- 370 .6
  ASRLIT04    371- 383 .6
  ASRLIT05    384- 396 .6
  ASRREA01    397- 409 .6
  ASRREA02    410- 422 .6
  ASRREA03    423- 435 .6
  ASRREA04    436- 448 .6
  ASRREA05    449- 461 .6
  ASDGPS      462- 462     
  ASDGBRN     463- 463     
  ASDGSATR    464- 464     
  ASDGSELF    465- 465     
  ASDGINFR    466- 466     
  ASDGTIC     467- 467     
  ASDGTIC2    468- 468     
  ASDGAFR     469- 469     
  ASDGAFR2    470- 470     
  ASIIBM01    471- 471     
  ASIIBM02    472- 472     
  ASIIBM03    473- 473     
  ASIIBM04    474- 474     
  ASIIBM05    475- 475     
  ASINBM01    476- 476     
  ASINBM02    477- 477     
  ASINBM03    478- 478     
  ASINBM04    479- 479     
  ASINBM05    480- 480     
  ASLIBM01    481- 481     
  ASLIBM02    482- 482     
  ASLIBM03    483- 483     
  ASLIBM04    484- 484     
  ASLIBM05    485- 485     
  ASLNBM01    486- 486     
  ASLNBM02    487- 487     
  ASLNBM03    488- 488     
  ASLNBM04    489- 489     
  ASLNBM05    490- 490     
  ASRIBM01    491- 491     
  ASRIBM02    492- 492     
  ASRIBM03    493- 493     
  ASRIBM04    494- 494     
  ASRIBM05    495- 495     
  ASRNBM01    496- 496     
  ASRNBM02    497- 497     
  ASRNBM03    498- 498     
  ASRNBM04    499- 499     
  ASRNBM05    500- 500     
;

%PUT INFO: assign labels to variables ;
LABEL
  IDCNTRY  = "*COUNTRY ID*"
  IDSCHOOL = "*SCHOOL ID*"
  IDCLASS  = "*CLASS ID*"
  IDGRADE  = "*GRADE*"
  IDSTUD   = "*STUDENT ID*"
  ITBIRTHM = "*DATE OF STUDENTS BIRTH\MONTH*"
  ITBIRTHY = "*DATE OF STUDENTS BIRTH\YEAR*"
  ITSEX    = "*SEX OF STUDENTS*"
  IDBOOK   = "*ACHIEVEMENT TEST BOOKLET*"
  ITADMINI = "*TEST ADMINISTRATORS POSITION*"
  ITDATEM  = "*DATE OF TESTING/MONTH*"
  ITDATEY  = "*DATE OF TESTING/YEAR*"
  ITLANG   = "*LANGUAGE OF TESTING*"
  IDPOP    = "POPULATION INDICATOR"
  IDGRADER = "LOWER/UPPER OF TARGET GRADE"
  INPRL01  = "IN PIRLS 2001"
  ASBGSEX  = "GEN/SEX OF STUDENT"
  ASBGBIRM = "GEN/BIRTH/MONTH"
  ASBGBIRY = "GEN/BIRTH/YEAR"
  ASBGTOC1 = "GEN/THINGS OUTSIDE SCH/READ ALOUD"
  ASBGTOC2 = "GEN/THINGS OUTSIDE SCH/LISTEN TO READING"
  ASBGTOC3 = "GEN/THINGS OUTSIDE SCH/TALK WITH FRIENDS"
  ASBGTOC4 = "GEN/THINGS OUTSIDE SCH/TALK WITH FAMILY"
  ASBGTOC5 = "GEN/THINGS OUTSIDE SCH/READING FOR FUN"
  ASBGTOC6 = "GEN/THINGS OUTSIDE SCH/READING FOR INFO"
  ASBGTOC7 = "GEN/THINGS OUTSIDE SCH/WATCHING TV"
  ASBGROC1 = "GEN/READING OUTSIDE SCH/COMIC BOOKS"
  ASBGROC2 = "GEN/READING OUTSIDE SCH/STORIES,NOVELS"
  ASBGROC3 = "GEN/READING OUTSIDE SCH/EXPLAINING BOOKS"
  ASBGROC4 = "GEN/READING OUTSIDE SCH/MAGAZINES"
  ASBGROC5 = "GEN/READING OUTSIDE SCH/NEWSPAPERS"
  ASBGROC6 = "GEN/READING OUTSIDE SCH/DIRECTIONS"
  ASBGROC7 = "GEN/READING OUTSIDE SCH/<SUBTITLES-TV>"
  ASBGROC8 = "GEN/READING OUTSIDE SCH/<CNTRY SPECIFIC>"
  ASBGBLIB = "GEN/USING LIBRARY TO READ FOR FUN"
  ASBGTVDY = "GEN/TIME FOR WATCHING TV,VIDEOS DAILY"
  ASBGTIC1 = "GEN/THINGS IN SCH/TCH READ ALOUD IN CLS"
  ASBGTIC2 = "GEN/THINGS IN SCH/READ ALOUD IN CLS"
  ASBGTIC3 = "GEN/THINGS IN SCH/READ ALOUD TO GROUP"
  ASBGTIC4 = "GEN/THINGS IN SCH/READ SILENTLY ALONE"
  ASBGTIC5 = "GEN/THINGS IN SCH/FOLLOW ALONG SILENTLY"
  ASBGTIC6 = "GEN/THINGS IN SCH/READ BOOKS"
  ASBGAFR1 = "GEN/AFTER READING IN CLS/WORKBOOK,-SHEET"
  ASBGAFR2 = "GEN/AFTER READING IN CLS/WRITE SOMETHING"
  ASBGAFR3 = "GEN/AFTER READING IN CLS/ANSWER QUESTION"
  ASBGAFR4 = "GEN/AFTER READING IN CLS/TALK WITH STD"
  ASBGAFR5 = "GEN/AFTER READING IN CLS/DRAW PICTURES"
  ASBGAFR6 = "GEN/AFTER READING IN CLS/ACT IN PLAY"
  ASBGAFR7 = "GEN/AFTER READING IN CLS/GROUP PROJECT"
  ASBGAFR8 = "GEN/AFTER READING IN CLS/TAKE QUIZ,TEST"
  ASBGHWRD = "GEN/READING HOMEWORK FROM TCH"
  ASBGHWTM = "GEN/SPENT TIME FOR READING HOMEWORK"
  ASBGUSPC = "GWN/THINGS WITH PC/EVER USE A PC"
  ASBGPCU1 = "GEN/USE PC WHERE/AT HOME"
  ASBGPCU2 = "GEN/USE PC WHERE/AT SCHOOL"
  ASBGPCU3 = "GEN/USE PC WHERE/AT SOME OTHER PLACE"
  ASBGPC1  = "GEN/THINGS WITH PC/PLAY PC GAMES"
  ASBGPC2  = "GEN/THINGS WITH PC/WRITE REPORTS,STORIES"
  ASBGPC3  = "GEN/THINGS WITH PC/LOOK UP INFO"
  ASBGPC4  = "GEN/THINGS WITH PC/SEND,READ E-MAILS"
  ASBGRST1 = "GEN/RDG STATEMENTS/READ ONLY IF HAVE TO"
  ASBGRST2 = "GEN/RDG STATEMENTS/LIKE TALK ABOUT BKS"
  ASBGRST3 = "GEN/RDG STATEMENTS/BK AS A PRESENT"
  ASBGRST4 = "GEN/RDG STATEMENTS/RDG IS BORING"
  ASBGRST5 = "GEN/RDG STATEMENTS/WELL FOR FUTURE"
  ASBGRST6 = "GEN/RDG STATEMENTS/I ENJOY RDG"
  ASBGRAB1 = "GEN/READING ABILITY/READING IS EASY"
  ASBGRAB2 = "GEN/READING ABILITY/NOT AS WELL AS OTHER"
  ASBGRAB3 = "GEN/READING ABILITY/UNDERSTAND"
  ASBGRAB4 = "GEN/READING ABILITY/READ ALOUD IS HARD"
  ASBGCST1 = "GEN/SCH STATEMENTS/FEEL SAFE AT SCH"
  ASBGCST2 = "GEN/SCH STATEMENTS/LIKE BEING IN SCH"
  ASBGCST3 = "GEN/SCH STATEMENTS/STD IN SCH WORK HARD"
  ASBGCST4 = "GEN/SCH STATEMENTS/TCH CARE ABOUT ME"
  ASBGCST5 = "GEN/SCH STATEMENTS/TCH WANT STD WRK HARD"
  ASBGSSTL = "GEN/THINGS AT SCH/STH STOLEN FROM ME"
  ASBGOSTL = "GEN/THINGS AT SCH/STH STOLEN FROM OTHERS"
  ASBGSBUL = "GEN/THINGS AT SCH/BULLIED BY OTHER STD"
  ASBGOBUL = "GEN/THINGS AT SCH/SO IN CLS WAS BULLIED"
  ASBGSHRT = "GEN/THINGS AT SCH/HURT BY ANOTHER STD"
  ASBGOHRT = "GEN/THINGS AT SCH/SO HURT BY ANOTHER STD"
  ASBGLAN1 = "GEN/LANGUAGES/LANGUAGE OF TEST"
  ASBGLAN2 = "GEN/LANGUAGES/<CNTRY-SPECIFIC>"
  ASBGLAN3 = "GEN/LANGUAGES/<CNTRY-SPECIFIC>"
  ASBGLAN4 = "GEN/LANGUAGES/<CNTRY-SPECIFIC>"
  ASBGLAN5 = "GEN/LANGUAGES/<CNTRY-SPECIFIC>"
  ASBGLAN6 = "GEN/LANGUAGES/OTHER"
  ASBGLANH = "GEN/LANGUAGE OF TEST AT HOME/HOW OFTEN"
  ASBGLANA = "GEN/LANGUAGE OF TEST AT HOME/WITH ADULTS"
  ASBGBOOK = "GEN/HOW MANY BOOKS AT HOME"
  ASBGPS1  = "GEN/THINGS AT HOME/PC"
  ASBGPS2  = "GEN/THINGS AT HOME/OWN STUDY DESK,TABLE"
  ASBGPS3  = "GEN/THINGS AT HOME/OWN BOOKS"
  ASBGPS4  = "GEN/THINGS AT HOME/DAILY NEWSPAPER"
  ASBGPS5  = "GEN/THINGS AT HOME/<COUNTRY-SPECIFIC>"
  ASBGPS6  = "GEN/THINGS AT HOME/<COUNTRY-SPECIFIC>"
  ASBGPS7  = "GEN/THINGS AT HOME/<COUNTRY-SPECIFIC>"
  ASBGPS8  = "GEN/THINGS AT HOME/<COUNTRY-SPECIFIC>"
  ASBGPS9  = "GEN/THINGS AT HOME/<COUNTRY-SPECIFIC>"
  ASBGPS10 = "GEN/THINGS AT HOME/<COUNTRY-SPECIFIC>"
  ASBGPS11 = "GEN/THINGS AT HOME/<COUNTRY-SPECIFIC>"
  ASBGPS12 = "GEN/THINGS AT HOME/<COUNTRY-SPECIFIC>"
  ASBGPEOP = "GEN/HOW MANY PEOPLE LIVE AT HOME"
  ASBGCHDH = "GEN/HOW MANY CHILDREN LIVE AT HOME"
  ASBGBRN1 = "GEN/CHILD BORN IN COUNTRY"
  ASBGBRN2 = "GEN/CHILD BORN IN COUNTRY/AGE OF COMING"
  ASBGBRNM = "GEN/BORN IN COUNTRY/MOTHER"
  ASBGBRNF = "GEN/BORN IN COUNTRY/FATHER"
  ITPART   = "FINAL PARTICIPATION INDICATOR"
  ASDGAGE  = "AGE IN YEARS AT DATE OF TESTING"
  HOUWGT   = "HOUSE WEIGHT"
  TOTWGT   = "TOTAL STUDENT WEIGHT"
  SENWGT   = "SENATE WEIGHT"
  WGTADJ1  = "SCHOOL WEIGHT ADJUSTMENT"
  WGTADJ3  = "STUDENT WEIGHT ADJUSTMENT"
  WGTFAC1  = "SCHOOL WEIGHT FACTOR"
  WGTFAC2  = "CLASS WEIGHT FACTOR"
  WGTFAC3  = "STUDENT WEIGHT FACTOR"
  JKZONE   = "JACKKNIFE ZONE"
  JKREP    = "JACKKNIFE REPLICATE CODE"
  DPCDATE  = "DATE OF CREATION AT DPC"
  IDSTRATE = "EXPLICIT STRATUM"
  IDSTRATI = "IMPLICIT STRATUM"
  ASRINF01 = "PLAUSIBLE VALUE: INFORMATION BLOCKS PV1"
  ASRINF02 = "PLAUSIBLE VALUE: INFORMATION BLOCKS PV2"
  ASRINF03 = "PLAUSIBLE VALUE: INFORMATION BLOCKS PV3"
  ASRINF04 = "PLAUSIBLE VALUE: INFORMATION BLOCKS PV4"
  ASRINF05 = "PLAUSIBLE VALUE: INFORMATION BLOCKS PV5"
  ASRLIT01 = "PLAUSIBLE VALUE: LITERARY BLOCKS PV1"
  ASRLIT02 = "PLAUSIBLE VALUE: LITERARY BLOCKS PV2"
  ASRLIT03 = "PLAUSIBLE VALUE: LITERARY BLOCKS PV3"
  ASRLIT04 = "PLAUSIBLE VALUE: LITERARY BLOCKS PV4"
  ASRLIT05 = "PLAUSIBLE VALUE: LITERARY BLOCKS PV5"
  ASRREA01 = "PLAUSIBLE VALUE: ALL BLOCKS PV1"
  ASRREA02 = "PLAUSIBLE VALUE: ALL BLOCKS PV2"
  ASRREA03 = "PLAUSIBLE VALUE: ALL BLOCKS PV3"
  ASRREA04 = "PLAUSIBLE VALUE: ALL BLOCKS PV4"
  ASRREA05 = "PLAUSIBLE VALUE: ALL BLOCKS PV5"
  ASDGPS   = "INDEX OF POSESSIONS IN THE HOME"
  ASDGBRN  = "STUDENTS PARENTS BORN IN COUNTRY"
  ASDGSATR = "INDEX/STUDENT ATTITUDE TO READING (SATR)"
  ASDGSELF = "INDEX/STUDENT READ. SELF CONCEPT (SRSC)"
  ASDGINFR = "STUDENT READ FOR INFORMATION OUTSIDE SCH"
  ASDGTIC  = "STUDENT REPORT READING ALOUD IN CLASS"
  ASDGTIC2 = "STUDENT REPORT INDEPENDENT READING"
  ASDGAFR  = "STUDENT DO PROJECT ABOUT CLASS READING"
  ASDGAFR2 = "STUDENT ANSWER QUESTIONS IN WRITING"
  ASIIBM01 = "INT. INFORMATION SCALE BENCHMARK REACHED"
  ASIIBM02 = "INT. INFORMATION SCALE BENCHMARK REACHED"
  ASIIBM03 = "INT. INFORMATION SCALE BENCHMARK REACHED"
  ASIIBM04 = "INT. INFORMATION SCALE BENCHMARK REACHED"
  ASIIBM05 = "INT. INFORMATION SCALE BENCHMARK REACHED"
  ASINBM01 = "NAT. INFORMATION SCALE BENCHMARK REACHED"
  ASINBM02 = "NAT. INFORMATION SCALE BENCHMARK REACHED"
  ASINBM03 = "NAT. INFORMATION SCALE BENCHMARK REACHED"
  ASINBM04 = "NAT. INFORMATION SCALE BENCHMARK REACHED"
  ASINBM05 = "NAT. INFORMATION SCALE BENCHMARK REACHED"
  ASLIBM01 = "INT. LITERARY SCALE BENCHMARK REACHED"
  ASLIBM02 = "INT. LITERARY SCALE BENCHMARK REACHED"
  ASLIBM03 = "INT. LITERARY SCALE BENCHMARK REACHED"
  ASLIBM04 = "INT. LITERARY SCALE BENCHMARK REACHED"
  ASLIBM05 = "INT. LITERARY SCALE BENCHMARK REACHED"
  ASLNBM01 = "NAT. LITERARY SCALE BENCHMARK REACHED"
  ASLNBM02 = "NAT. LITERARY SCALE BENCHMARK REACHED"
  ASLNBM03 = "NAT. LITERARY SCALE BENCHMARK REACHED"
  ASLNBM04 = "NAT. LITERARY SCALE BENCHMARK REACHED"
  ASLNBM05 = "NAT. LITERARY SCALE BENCHMARK REACHED"
  ASRIBM01 = "INT. READING SCALE BENCHMARK REACHED"
  ASRIBM02 = "INT. READING SCALE BENCHMARK REACHED"
  ASRIBM03 = "INT. READING SCALE BENCHMARK REACHED"
  ASRIBM04 = "INT. READING SCALE BENCHMARK REACHED"
  ASRIBM05 = "INT. READING SCALE BENCHMARK REACHED"
  ASRNBM01 = "NAT. READING SCALE BENCHMARK REACHED"
  ASRNBM02 = "NAT. READING SCALE BENCHMARK REACHED"
  ASRNBM03 = "NAT. READING SCALE BENCHMARK REACHED"
  ASRNBM04 = "NAT. READING SCALE BENCHMARK REACHED"
  ASRNBM05 = "NAT. READING SCALE BENCHMARK REACHED"
;

%PUT INFO: recode "not administered" data to missing code ".A" ;
*NOTE: If a CHECK variable is coded correctly with a BLANK, it will be recoded
       to "1", otherwise it will be recoded to "0" ;

IF IDGRADE  = 98               THEN IDGRADE  = .A ;
IF ITBIRTHM = 98               THEN ITBIRTHM = .A ;
IF ITBIRTHY = 98               THEN ITBIRTHY = .A ;
IF ITSEX    = 8                THEN ITSEX    = .A ;
IF ITADMINI = 8                THEN ITADMINI = .A ;
IF ITLANG   = 8                THEN ITLANG   = .A ;
IF IDPOP    = 8                THEN IDPOP    = .A ;
IF IDGRADER = 8                THEN IDGRADER = .A ;
IF INPRL01  = 8                THEN INPRL01  = .A ;
IF ASBGSEX  = 8                THEN ASBGSEX  = .A ;
IF ASBGBIRM = 98               THEN ASBGBIRM = .A ;
IF ASBGBIRY = 98               THEN ASBGBIRY = .A ;
IF ASBGTOC1 = 8                THEN ASBGTOC1 = .A ;
IF ASBGTOC2 = 8                THEN ASBGTOC2 = .A ;
IF ASBGTOC3 = 8                THEN ASBGTOC3 = .A ;
IF ASBGTOC4 = 8                THEN ASBGTOC4 = .A ;
IF ASBGTOC5 = 8                THEN ASBGTOC5 = .A ;
IF ASBGTOC6 = 8                THEN ASBGTOC6 = .A ;
IF ASBGTOC7 = 8                THEN ASBGTOC7 = .A ;
IF ASBGROC1 = 8                THEN ASBGROC1 = .A ;
IF ASBGROC2 = 8                THEN ASBGROC2 = .A ;
IF ASBGROC3 = 8                THEN ASBGROC3 = .A ;
IF ASBGROC4 = 8                THEN ASBGROC4 = .A ;
IF ASBGROC5 = 8                THEN ASBGROC5 = .A ;
IF ASBGROC6 = 8                THEN ASBGROC6 = .A ;
IF ASBGROC7 = 8                THEN ASBGROC7 = .A ;
IF ASBGROC8 = 8                THEN ASBGROC8 = .A ;
IF ASBGBLIB = 8                THEN ASBGBLIB = .A ;
IF ASBGTVDY = 8                THEN ASBGTVDY = .A ;
IF ASBGTIC1 = 8                THEN ASBGTIC1 = .A ;
IF ASBGTIC2 = 8                THEN ASBGTIC2 = .A ;
IF ASBGTIC3 = 8                THEN ASBGTIC3 = .A ;
IF ASBGTIC4 = 8                THEN ASBGTIC4 = .A ;
IF ASBGTIC5 = 8                THEN ASBGTIC5 = .A ;
IF ASBGTIC6 = 8                THEN ASBGTIC6 = .A ;
IF ASBGAFR1 = 8                THEN ASBGAFR1 = .A ;
IF ASBGAFR2 = 8                THEN ASBGAFR2 = .A ;
IF ASBGAFR3 = 8                THEN ASBGAFR3 = .A ;
IF ASBGAFR4 = 8                THEN ASBGAFR4 = .A ;
IF ASBGAFR5 = 8                THEN ASBGAFR5 = .A ;
IF ASBGAFR6 = 8                THEN ASBGAFR6 = .A ;
IF ASBGAFR7 = 8                THEN ASBGAFR7 = .A ;
IF ASBGAFR8 = 8                THEN ASBGAFR8 = .A ;
IF ASBGHWRD = 8                THEN ASBGHWRD = .A ;
IF ASBGHWTM = 8                THEN ASBGHWTM = .A ;
IF ASBGUSPC = 8                THEN ASBGUSPC = .A ;
IF ASBGPCU1 = 8                THEN ASBGPCU1 = .A ;
IF ASBGPCU2 = 8                THEN ASBGPCU2 = .A ;
IF ASBGPCU3 = 8                THEN ASBGPCU3 = .A ;
IF ASBGPC1  = 8                THEN ASBGPC1  = .A ;
IF ASBGPC2  = 8                THEN ASBGPC2  = .A ;
IF ASBGPC3  = 8                THEN ASBGPC3  = .A ;
IF ASBGPC4  = 8                THEN ASBGPC4  = .A ;
IF ASBGRST1 = 8                THEN ASBGRST1 = .A ;
IF ASBGRST2 = 8                THEN ASBGRST2 = .A ;
IF ASBGRST3 = 8                THEN ASBGRST3 = .A ;
IF ASBGRST4 = 8                THEN ASBGRST4 = .A ;
IF ASBGRST5 = 8                THEN ASBGRST5 = .A ;
IF ASBGRST6 = 8                THEN ASBGRST6 = .A ;
IF ASBGRAB1 = 8                THEN ASBGRAB1 = .A ;
IF ASBGRAB2 = 8                THEN ASBGRAB2 = .A ;
IF ASBGRAB3 = 8                THEN ASBGRAB3 = .A ;
IF ASBGRAB4 = 8                THEN ASBGRAB4 = .A ;
IF ASBGCST1 = 8                THEN ASBGCST1 = .A ;
IF ASBGCST2 = 8                THEN ASBGCST2 = .A ;
IF ASBGCST3 = 8                THEN ASBGCST3 = .A ;
IF ASBGCST4 = 8                THEN ASBGCST4 = .A ;
IF ASBGCST5 = 8                THEN ASBGCST5 = .A ;
IF ASBGSSTL = 8                THEN ASBGSSTL = .A ;
IF ASBGOSTL = 8                THEN ASBGOSTL = .A ;
IF ASBGSBUL = 8                THEN ASBGSBUL = .A ;
IF ASBGOBUL = 8                THEN ASBGOBUL = .A ;
IF ASBGSHRT = 8                THEN ASBGSHRT = .A ;
IF ASBGOHRT = 8                THEN ASBGOHRT = .A ;
IF ASBGLAN1 = 8                THEN ASBGLAN1 = .A ;
IF ASBGLAN2 = 8                THEN ASBGLAN2 = .A ;
IF ASBGLAN3 = 8                THEN ASBGLAN3 = .A ;
IF ASBGLAN4 = 8                THEN ASBGLAN4 = .A ;
IF ASBGLAN5 = 8                THEN ASBGLAN5 = .A ;
IF ASBGLAN6 = 8                THEN ASBGLAN6 = .A ;
IF ASBGLANH = 8                THEN ASBGLANH = .A ;
IF ASBGLANA = 8                THEN ASBGLANA = .A ;
IF ASBGBOOK = 8                THEN ASBGBOOK = .A ;
IF ASBGPS1  = 8                THEN ASBGPS1  = .A ;
IF ASBGPS2  = 8                THEN ASBGPS2  = .A ;
IF ASBGPS3  = 8                THEN ASBGPS3  = .A ;
IF ASBGPS4  = 8                THEN ASBGPS4  = .A ;
IF ASBGPS5  = 8                THEN ASBGPS5  = .A ;
IF ASBGPS6  = 8                THEN ASBGPS6  = .A ;
IF ASBGPS7  = 8                THEN ASBGPS7  = .A ;
IF ASBGPS8  = 8                THEN ASBGPS8  = .A ;
IF ASBGPS9  = 8                THEN ASBGPS9  = .A ;
IF ASBGPS10 = 8                THEN ASBGPS10 = .A ;
IF ASBGPS11 = 8                THEN ASBGPS11 = .A ;
IF ASBGPS12 = 8                THEN ASBGPS12 = .A ;
IF ASBGPEOP = 98               THEN ASBGPEOP = .A ;
IF ASBGCHDH = 98               THEN ASBGCHDH = .A ;
IF ASBGBRN1 = 8                THEN ASBGBRN1 = .A ;
IF ASBGBRN2 = 98               THEN ASBGBRN2 = .A ;
IF ASBGBRNM = 8                THEN ASBGBRNM = .A ;
IF ASBGBRNF = 8                THEN ASBGBRNF = .A ;
IF ASDGAGE  = 98               THEN ASDGAGE  = .A ;
IF HOUWGT   = 999998           THEN HOUWGT   = .A ;
IF TOTWGT   = 999998           THEN TOTWGT   = .A ;
IF SENWGT   = 999998           THEN SENWGT   = .A ;
IF WGTADJ1  = 999998           THEN WGTADJ1  = .A ;
IF WGTADJ3  = 999998           THEN WGTADJ3  = .A ;
IF WGTFAC1  = 999998           THEN WGTFAC1  = .A ;
IF WGTFAC2  = 999998           THEN WGTFAC2  = .A ;
IF WGTFAC3  = 999998           THEN WGTFAC3  = .A ;
IF JKZONE   = 98               THEN JKZONE   = .A ;
IF JKREP    = 8                THEN JKREP    = .A ;
IF IDSTRATE = 998              THEN IDSTRATE = .A ;
IF IDSTRATI = 998              THEN IDSTRATI = .A ;
IF ASRINF01 = 999998           THEN ASRINF01 = .A ;
IF ASRINF02 = 999998           THEN ASRINF02 = .A ;
IF ASRINF03 = 999998           THEN ASRINF03 = .A ;
IF ASRINF04 = 999998           THEN ASRINF04 = .A ;
IF ASRINF05 = 999998           THEN ASRINF05 = .A ;
IF ASRLIT01 = 999998           THEN ASRLIT01 = .A ;
IF ASRLIT02 = 999998           THEN ASRLIT02 = .A ;
IF ASRLIT03 = 999998           THEN ASRLIT03 = .A ;
IF ASRLIT04 = 999998           THEN ASRLIT04 = .A ;
IF ASRLIT05 = 999998           THEN ASRLIT05 = .A ;
IF ASRREA01 = 999998           THEN ASRREA01 = .A ;
IF ASRREA02 = 999998           THEN ASRREA02 = .A ;
IF ASRREA03 = 999998           THEN ASRREA03 = .A ;
IF ASRREA04 = 999998           THEN ASRREA04 = .A ;
IF ASRREA05 = 999998           THEN ASRREA05 = .A ;
IF ASDGPS   = 8                THEN ASDGPS   = .A ;
IF ASDGBRN  = 8                THEN ASDGBRN  = .A ;
IF ASDGSATR = 8                THEN ASDGSATR = .A ;
IF ASDGSELF = 8                THEN ASDGSELF = .A ;
IF ASDGINFR = 8                THEN ASDGINFR = .A ;
IF ASDGTIC  = 8                THEN ASDGTIC  = .A ;
IF ASDGTIC2 = 8                THEN ASDGTIC2 = .A ;
IF ASDGAFR  = 8                THEN ASDGAFR  = .A ;
IF ASDGAFR2 = 8                THEN ASDGAFR2 = .A ;
IF ASIIBM01 = 8                THEN ASIIBM01 = .A ;
IF ASIIBM02 = 8                THEN ASIIBM02 = .A ;
IF ASIIBM03 = 8                THEN ASIIBM03 = .A ;
IF ASIIBM04 = 8                THEN ASIIBM04 = .A ;
IF ASIIBM05 = 8                THEN ASIIBM05 = .A ;
IF ASINBM01 = 8                THEN ASINBM01 = .A ;
IF ASINBM02 = 8                THEN ASINBM02 = .A ;
IF ASINBM03 = 8                THEN ASINBM03 = .A ;
IF ASINBM04 = 8                THEN ASINBM04 = .A ;
IF ASINBM05 = 8                THEN ASINBM05 = .A ;
IF ASLIBM01 = 8                THEN ASLIBM01 = .A ;
IF ASLIBM02 = 8                THEN ASLIBM02 = .A ;
IF ASLIBM03 = 8                THEN ASLIBM03 = .A ;
IF ASLIBM04 = 8                THEN ASLIBM04 = .A ;
IF ASLIBM05 = 8                THEN ASLIBM05 = .A ;
IF ASLNBM01 = 8                THEN ASLNBM01 = .A ;
IF ASLNBM02 = 8                THEN ASLNBM02 = .A ;
IF ASLNBM03 = 8                THEN ASLNBM03 = .A ;
IF ASLNBM04 = 8                THEN ASLNBM04 = .A ;
IF ASLNBM05 = 8                THEN ASLNBM05 = .A ;
IF ASRIBM01 = 8                THEN ASRIBM01 = .A ;
IF ASRIBM02 = 8                THEN ASRIBM02 = .A ;
IF ASRIBM03 = 8                THEN ASRIBM03 = .A ;
IF ASRIBM04 = 8                THEN ASRIBM04 = .A ;
IF ASRIBM05 = 8                THEN ASRIBM05 = .A ;
IF ASRNBM01 = 8                THEN ASRNBM01 = .A ;
IF ASRNBM02 = 8                THEN ASRNBM02 = .A ;
IF ASRNBM03 = 8                THEN ASRNBM03 = .A ;
IF ASRNBM04 = 8                THEN ASRNBM04 = .A ;
IF ASRNBM05 = 8                THEN ASRNBM05 = .A ;

%PUT INFO: recode special missing codes to SAS missing codes ;
*NOTE: Special missing codes are recoded to SAS
       character - missing codes;

IF ASBGPCU1 = 6                THEN ASBGPCU1 = .B ;
IF ASBGPCU2 = 6                THEN ASBGPCU2 = .B ;
IF ASBGPCU3 = 6                THEN ASBGPCU3 = .B ;
IF ASBGPC1  = 6                THEN ASBGPC1  = .B ;
IF ASBGPC2  = 6                THEN ASBGPC2  = .B ;
IF ASBGPC3  = 6                THEN ASBGPC3  = .B ;
IF ASBGPC4  = 6                THEN ASBGPC4  = .B ;
IF ASBGBRN2 = 96               THEN ASBGBRN2 = .B ;

%PUT INFO: recode omitted data to missing code "." ;
*NOTE: BLANKS are recoded to SYSMIS by SAS ;

IF ITBIRTHM = 99               THEN ITBIRTHM = . ;
IF ITBIRTHY = 99               THEN ITBIRTHY = . ;
IF ITSEX    = 9                THEN ITSEX    = . ;
IF IDBOOK   = 99               THEN IDBOOK   = . ;
IF ITADMINI = 9                THEN ITADMINI = . ;
IF ITLANG   = 9                THEN ITLANG   = . ;
IF IDPOP    = 9                THEN IDPOP    = . ;
IF IDGRADER = 9                THEN IDGRADER = . ;
IF INPRL01  = 9                THEN INPRL01  = . ;
IF ASBGSEX  = 9                THEN ASBGSEX  = . ;
IF ASBGBIRM = 99               THEN ASBGBIRM = . ;
IF ASBGBIRY = 99               THEN ASBGBIRY = . ;
IF ASBGTOC1 = 9                THEN ASBGTOC1 = . ;
IF ASBGTOC2 = 9                THEN ASBGTOC2 = . ;
IF ASBGTOC3 = 9                THEN ASBGTOC3 = . ;
IF ASBGTOC4 = 9                THEN ASBGTOC4 = . ;
IF ASBGTOC5 = 9                THEN ASBGTOC5 = . ;
IF ASBGTOC6 = 9                THEN ASBGTOC6 = . ;
IF ASBGTOC7 = 9                THEN ASBGTOC7 = . ;
IF ASBGROC1 = 9                THEN ASBGROC1 = . ;
IF ASBGROC2 = 9                THEN ASBGROC2 = . ;
IF ASBGROC3 = 9                THEN ASBGROC3 = . ;
IF ASBGROC4 = 9                THEN ASBGROC4 = . ;
IF ASBGROC5 = 9                THEN ASBGROC5 = . ;
IF ASBGROC6 = 9                THEN ASBGROC6 = . ;
IF ASBGROC7 = 9                THEN ASBGROC7 = . ;
IF ASBGROC8 = 9                THEN ASBGROC8 = . ;
IF ASBGBLIB = 9                THEN ASBGBLIB = . ;
IF ASBGTVDY = 9                THEN ASBGTVDY = . ;
IF ASBGTIC1 = 9                THEN ASBGTIC1 = . ;
IF ASBGTIC2 = 9                THEN ASBGTIC2 = . ;
IF ASBGTIC3 = 9                THEN ASBGTIC3 = . ;
IF ASBGTIC4 = 9                THEN ASBGTIC4 = . ;
IF ASBGTIC5 = 9                THEN ASBGTIC5 = . ;
IF ASBGTIC6 = 9                THEN ASBGTIC6 = . ;
IF ASBGAFR1 = 9                THEN ASBGAFR1 = . ;
IF ASBGAFR2 = 9                THEN ASBGAFR2 = . ;
IF ASBGAFR3 = 9                THEN ASBGAFR3 = . ;
IF ASBGAFR4 = 9                THEN ASBGAFR4 = . ;
IF ASBGAFR5 = 9                THEN ASBGAFR5 = . ;
IF ASBGAFR6 = 9                THEN ASBGAFR6 = . ;
IF ASBGAFR7 = 9                THEN ASBGAFR7 = . ;
IF ASBGAFR8 = 9                THEN ASBGAFR8 = . ;
IF ASBGHWRD = 9                THEN ASBGHWRD = . ;
IF ASBGHWTM = 9                THEN ASBGHWTM = . ;
IF ASBGUSPC = 9                THEN ASBGUSPC = . ;
IF ASBGPCU1 = 9                THEN ASBGPCU1 = . ;
IF ASBGPCU2 = 9                THEN ASBGPCU2 = . ;
IF ASBGPCU3 = 9                THEN ASBGPCU3 = . ;
IF ASBGPC1  = 9                THEN ASBGPC1  = . ;
IF ASBGPC2  = 9                THEN ASBGPC2  = . ;
IF ASBGPC3  = 9                THEN ASBGPC3  = . ;
IF ASBGPC4  = 9                THEN ASBGPC4  = . ;
IF ASBGRST1 = 9                THEN ASBGRST1 = . ;
IF ASBGRST2 = 9                THEN ASBGRST2 = . ;
IF ASBGRST3 = 9                THEN ASBGRST3 = . ;
IF ASBGRST4 = 9                THEN ASBGRST4 = . ;
IF ASBGRST5 = 9                THEN ASBGRST5 = . ;
IF ASBGRST6 = 9                THEN ASBGRST6 = . ;
IF ASBGRAB1 = 9                THEN ASBGRAB1 = . ;
IF ASBGRAB2 = 9                THEN ASBGRAB2 = . ;
IF ASBGRAB3 = 9                THEN ASBGRAB3 = . ;
IF ASBGRAB4 = 9                THEN ASBGRAB4 = . ;
IF ASBGCST1 = 9                THEN ASBGCST1 = . ;
IF ASBGCST2 = 9                THEN ASBGCST2 = . ;
IF ASBGCST3 = 9                THEN ASBGCST3 = . ;
IF ASBGCST4 = 9                THEN ASBGCST4 = . ;
IF ASBGCST5 = 9                THEN ASBGCST5 = . ;
IF ASBGSSTL = 9                THEN ASBGSSTL = . ;
IF ASBGOSTL = 9                THEN ASBGOSTL = . ;
IF ASBGSBUL = 9                THEN ASBGSBUL = . ;
IF ASBGOBUL = 9                THEN ASBGOBUL = . ;
IF ASBGSHRT = 9                THEN ASBGSHRT = . ;
IF ASBGOHRT = 9                THEN ASBGOHRT = . ;
IF ASBGLAN1 = 9                THEN ASBGLAN1 = . ;
IF ASBGLAN2 = 9                THEN ASBGLAN2 = . ;
IF ASBGLAN3 = 9                THEN ASBGLAN3 = . ;
IF ASBGLAN4 = 9                THEN ASBGLAN4 = . ;
IF ASBGLAN5 = 9                THEN ASBGLAN5 = . ;
IF ASBGLAN6 = 9                THEN ASBGLAN6 = . ;
IF ASBGLANH = 9                THEN ASBGLANH = . ;
IF ASBGLANA = 9                THEN ASBGLANA = . ;
IF ASBGBOOK = 9                THEN ASBGBOOK = . ;
IF ASBGPS1  = 9                THEN ASBGPS1  = . ;
IF ASBGPS2  = 9                THEN ASBGPS2  = . ;
IF ASBGPS3  = 9                THEN ASBGPS3  = . ;
IF ASBGPS4  = 9                THEN ASBGPS4  = . ;
IF ASBGPS5  = 9                THEN ASBGPS5  = . ;
IF ASBGPS6  = 9                THEN ASBGPS6  = . ;
IF ASBGPS7  = 9                THEN ASBGPS7  = . ;
IF ASBGPS8  = 9                THEN ASBGPS8  = . ;
IF ASBGPS9  = 9                THEN ASBGPS9  = . ;
IF ASBGPS10 = 9                THEN ASBGPS10 = . ;
IF ASBGPS11 = 9                THEN ASBGPS11 = . ;
IF ASBGPS12 = 9                THEN ASBGPS12 = . ;
IF ASBGPEOP = 99               THEN ASBGPEOP = . ;
IF ASBGCHDH = 99               THEN ASBGCHDH = . ;
IF ASBGBRN1 = 9                THEN ASBGBRN1 = . ;
IF ASBGBRN2 = 99               THEN ASBGBRN2 = . ;
IF ASBGBRNM = 9                THEN ASBGBRNM = . ;
IF ASBGBRNF = 9                THEN ASBGBRNF = . ;
IF ASDGAGE  = 99               THEN ASDGAGE  = . ;
IF HOUWGT   = 999999           THEN HOUWGT   = . ;
IF TOTWGT   = 999999           THEN TOTWGT   = . ;
IF SENWGT   = 999999           THEN SENWGT   = . ;
IF WGTADJ1  = 999999           THEN WGTADJ1  = . ;
IF WGTADJ3  = 999999           THEN WGTADJ3  = . ;
IF WGTFAC1  = 999999           THEN WGTFAC1  = . ;
IF WGTFAC2  = 999999           THEN WGTFAC2  = . ;
IF WGTFAC3  = 999999           THEN WGTFAC3  = . ;
IF JKZONE   = 99               THEN JKZONE   = . ;
IF JKREP    = 9                THEN JKREP    = . ;
IF IDSTRATE = 999              THEN IDSTRATE = . ;
IF IDSTRATI = 999              THEN IDSTRATI = . ;
IF ASRINF01 = 999999           THEN ASRINF01 = . ;
IF ASRINF02 = 999999           THEN ASRINF02 = . ;
IF ASRINF03 = 999999           THEN ASRINF03 = . ;
IF ASRINF04 = 999999           THEN ASRINF04 = . ;
IF ASRINF05 = 999999           THEN ASRINF05 = . ;
IF ASRLIT01 = 999999           THEN ASRLIT01 = . ;
IF ASRLIT02 = 999999           THEN ASRLIT02 = . ;
IF ASRLIT03 = 999999           THEN ASRLIT03 = . ;
IF ASRLIT04 = 999999           THEN ASRLIT04 = . ;
IF ASRLIT05 = 999999           THEN ASRLIT05 = . ;
IF ASRREA01 = 999999           THEN ASRREA01 = . ;
IF ASRREA02 = 999999           THEN ASRREA02 = . ;
IF ASRREA03 = 999999           THEN ASRREA03 = . ;
IF ASRREA04 = 999999           THEN ASRREA04 = . ;
IF ASRREA05 = 999999           THEN ASRREA05 = . ;
IF ASDGPS   = 9                THEN ASDGPS   = . ;
IF ASDGBRN  = 9                THEN ASDGBRN  = . ;
IF ASDGSATR = 9                THEN ASDGSATR = . ;
IF ASDGSELF = 9                THEN ASDGSELF = . ;
IF ASDGINFR = 9                THEN ASDGINFR = . ;
IF ASDGTIC  = 9                THEN ASDGTIC  = . ;
IF ASDGTIC2 = 9                THEN ASDGTIC2 = . ;
IF ASDGAFR  = 9                THEN ASDGAFR  = . ;
IF ASDGAFR2 = 9                THEN ASDGAFR2 = . ;
IF ASIIBM01 = 9                THEN ASIIBM01 = . ;
IF ASIIBM02 = 9                THEN ASIIBM02 = . ;
IF ASIIBM03 = 9                THEN ASIIBM03 = . ;
IF ASIIBM04 = 9                THEN ASIIBM04 = . ;
IF ASIIBM05 = 9                THEN ASIIBM05 = . ;
IF ASINBM01 = 9                THEN ASINBM01 = . ;
IF ASINBM02 = 9                THEN ASINBM02 = . ;
IF ASINBM03 = 9                THEN ASINBM03 = . ;
IF ASINBM04 = 9                THEN ASINBM04 = . ;
IF ASINBM05 = 9                THEN ASINBM05 = . ;
IF ASLIBM01 = 9                THEN ASLIBM01 = . ;
IF ASLIBM02 = 9                THEN ASLIBM02 = . ;
IF ASLIBM03 = 9                THEN ASLIBM03 = . ;
IF ASLIBM04 = 9                THEN ASLIBM04 = . ;
IF ASLIBM05 = 9                THEN ASLIBM05 = . ;
IF ASLNBM01 = 9                THEN ASLNBM01 = . ;
IF ASLNBM02 = 9                THEN ASLNBM02 = . ;
IF ASLNBM03 = 9                THEN ASLNBM03 = . ;
IF ASLNBM04 = 9                THEN ASLNBM04 = . ;
IF ASLNBM05 = 9                THEN ASLNBM05 = . ;
IF ASRIBM01 = 9                THEN ASRIBM01 = . ;
IF ASRIBM02 = 9                THEN ASRIBM02 = . ;
IF ASRIBM03 = 9                THEN ASRIBM03 = . ;
IF ASRIBM04 = 9                THEN ASRIBM04 = . ;
IF ASRIBM05 = 9                THEN ASRIBM05 = . ;
IF ASRNBM01 = 9                THEN ASRNBM01 = . ;
IF ASRNBM02 = 9                THEN ASRNBM02 = . ;
IF ASRNBM03 = 9                THEN ASRNBM03 = . ;
IF ASRNBM04 = 9                THEN ASRNBM04 = . ;
IF ASRNBM05 = 9                THEN ASRNBM05 = . ;

%PUT INFO: assign variable labels to recoded variables ;
LABEL
;

RUN ;

proc sort ; by idcntry idstud;

       %let i = %eval(&i + 1);
     %end;
run;
%mend doit;

%doit;







