%let cty = ARG BGR BLZ CAN COL CYP CZE DEU ENG FRA
           GRC HKG HUN IRN ISL ISR ITA KWT LTU LVA
           MAR MDA MKD NLD NOR NZL ROM RUS SCO SGP
           SVK SVN SWE TUR USA SE3;

Options nosource nocenter;

LIBNAME libdat  "c:\pirls\Data" ;
LIBNAME library "c:\pirls\Data" ;

%macro doit;
  %let i = 1;
     %do %while(%length(%scan(&cty,&i)));
       %let ccode = %lowcase(%scan(&cty,&i));

%let fname= ash&ccode.r1 ;

FILENAME rawinp "c:\pirls\Data\&fname..dat" ;

%PUT INFO: data set definition ;
%PUT INFO: data set definitions have to be modified ;

*Output data set ;
data libdat.&fname;

*NOTE: LRECL may need to be modified ;
INFILE rawinp LRECL=1250 END=eof LENGTH=lnline LINE=ln MISSOVER ;

%PUT INFO: shorten variable definitions to save secondary storage area ;
%PUT INFO: refer to the SAS manual for an appropriate length for variables ;

*NOTE: The LENGTH statement in a data step specifies the number of bytes, the
       SAS - sytem uses for storing values of variables in each data set being created. ;
LENGTH DEFAULT=5 ;
LENGTH      IDCNTRY    5 ;
LENGTH      IDSCHOOL   4 ;
LENGTH      IDCLASS    6 ;
LENGTH      IDSTUD     8 ;
LENGTH      IDPOP      3 ;
LENGTH      IDGRADER   3 ;
LENGTH      INPRL01    3 ;
LENGTH      ASBHCPLF   3 ;
LENGTH      ASBHCPLM   3 ;
LENGTH      ASBHCPLO   3 ;
LENGTH      ASBHAC1    3 ;
LENGTH      ASBHAC2    3 ;
LENGTH      ASBHAC3    3 ;
LENGTH      ASBHAC4    3 ;
LENGTH      ASBHAC5    3 ;
LENGTH      ASBHAC6    3 ;
LENGTH      ASBHAC7    3 ;
LENGTH      ASBHAC8    3 ;
LENGTH      ASBHAC9    3 ;
LENGTH      ASBHAC10   3 ;
LENGTH      ASBHAC11   3 ;
LENGTH      ASBH0ATT   3 ;
LENGTH      ASBH0TIM   3 ;
LENGTH      ASBHAGE    3 ;
LENGTH      ASBHABI1   3 ;
LENGTH      ASBHABI2   3 ;
LENGTH      ASBHABI3   3 ;
LENGTH      ASBHABI4   3 ;
LENGTH      ASBHABI5   3 ;
LENGTH      ASBHTWC1   3 ;
LENGTH      ASBHTWC2   3 ;
LENGTH      ASBHTWC3   3 ;
LENGTH      ASBHTWC4   3 ;
LENGTH      ASBHTWC5   3 ;
LENGTH      ASBHTWC6   3 ;
LENGTH      ASBHTWC7   3 ;
LENGTH      ASBHTWC8   3 ;
LENGTH      ASBHCON1   3 ;
LENGTH      ASBHCON2   3 ;
LENGTH      ASBHCON3   3 ;
LENGTH      ASBHTHK1   3 ;
LENGTH      ASBHTHK2   3 ;
LENGTH      ASBHTHK3   3 ;
LENGTH      ASBHREAD   3 ;
LENGTH      ASBHRRE1   3 ;
LENGTH      ASBHRRE2   3 ;
LENGTH      ASBHRRE3   3 ;
LENGTH      ASBHRRE4   3 ;
LENGTH      ASBHRRE5   3 ;
LENGTH      ASBHSTM1   3 ;
LENGTH      ASBHSTM2   3 ;
LENGTH      ASBHSTM3   3 ;
LENGTH      ASBHSTM4   3 ;
LENGTH      ASBHSTM5   3 ;
LENGTH      ASBHBOOK   3 ;
LENGTH      ASBHCHBK   3 ;
LENGTH      ASBHEDUF   3 ;
LENGTH      ASBHEDUM   3 ;
LENGTH      ASBHEMPF   3 ;
LENGTH      ASBHEMPM   3 ;
LENGTH      ASBHMJF    3 ;
LENGTH      ASBHMJM    3 ;
LENGTH      ASBHWELL   3 ;
LENGTH      ASBHINCM   3 ;
LENGTH      ASBHCOMP   3 ;
LENGTH      DPCDATE    6 ;
LENGTH      ASDHHLA    3 ;
LENGTH      ASDHEDUP   3 ;
LENGTH      ASDHPEMP   3 ;
LENGTH      ASDHPATR   3 ;
LENGTH      ASDHABI    3 ;
LENGTH      ASDHCON    3 ;


%PUT INFO: Missing category A refers to "not administered" values ;
%PUT INFO: Missing category I refers to "invalid" values ;
%PUT INFO: Missing category B refers to "logically not applicable" values ;
%PUT INFO: Missing category R refers to "not reached" items ;
%PUT INFO: Missing category . refers to missing values ;
MISSING A I B R ;

*NOTE: The INPUT statement reads raw data and assigns variable names.
       The positions specified below correspond to the positions of the variables
       in the raw data file. ;

INPUT
  IDCNTRY       1-   5     
  IDSCHOOL      6-   9     
  IDCLASS      10-  15     
  IDSTUD       16-  23     
  IDPOP        24-  24     
  IDGRADER     25-  25     
  INPRL01      26-  26     
  ASBHCPLF     27-  27     
  ASBHCPLM     28-  28     
  ASBHCPLO     29-  29     
  ASBHAC1      30-  30     
  ASBHAC2      31-  31     
  ASBHAC3      32-  32     
  ASBHAC4      33-  33     
  ASBHAC5      34-  34     
  ASBHAC6      35-  35     
  ASBHAC7      36-  36     
  ASBHAC8      37-  37     
  ASBHAC9      38-  38     
  ASBHAC10     39-  39     
  ASBHAC11     40-  40     
  ASBH0ATT     41-  41     
  ASBH0TIM     42-  42     
  ASBHAGE      43-  43     
  ASBHABI1     44-  44     
  ASBHABI2     45-  45     
  ASBHABI3     46-  46     
  ASBHABI4     47-  47     
  ASBHABI5     48-  48     
  ASBHTWC1     49-  49     
  ASBHTWC2     50-  50     
  ASBHTWC3     51-  51     
  ASBHTWC4     52-  52     
  ASBHTWC5     53-  53     
  ASBHTWC6     54-  54     
  ASBHTWC7     55-  55     
  ASBHTWC8     56-  56     
  ASBHCON1     57-  57     
  ASBHCON2     58-  58     
  ASBHCON3     59-  59     
  ASBHTHK1     60-  60     
  ASBHTHK2     61-  61     
  ASBHTHK3     62-  62     
  ASBHREAD     63-  63     
  ASBHRRE1     64-  64     
  ASBHRRE2     65-  65     
  ASBHRRE3     66-  66     
  ASBHRRE4     67-  67     
  ASBHRRE5     68-  68     
  ASBHSTM1     69-  69     
  ASBHSTM2     70-  70     
  ASBHSTM3     71-  71     
  ASBHSTM4     72-  72     
  ASBHSTM5     73-  73     
  ASBHBOOK     74-  74     
  ASBHCHBK     75-  75     
  ASBHEDUF     76-  77     
  ASBHEDUM     78-  79     
  ASBHEMPF     80-  80     
  ASBHEMPM     81-  81     
  ASBHMJF      82-  83     
  ASBHMJM      84-  85     
  ASBHWELL     86-  86     
  ASBHINCM     87-  87     
  ASBHCOMP     88-  89     
  DPCDATE      90-  95     
  ASDHHLA      96-  96     
  ASDHEDUP     97-  97     
  ASDHPEMP     98-  98     
  ASDHPATR     99-  99     
  ASDHABI     100- 100     
  ASDHCON     101- 101     
;

%PUT INFO: assign labels to variables ;
LABEL
  IDCNTRY  = "*COUNTRY ID*"
  IDSCHOOL = "*SCHOOL ID*"
  IDCLASS  = "*CLASS ID*"
  IDSTUD   = "*STUDENT ID*"
  IDPOP    = "POPULATION INDICATOR"
  IDGRADER = "LOWER/UPPER OF TARGET GRADE"
  INPRL01  = "INDICATOR VARIABLE"
  ASBHCPLF = "GEN/COMPLETED BY/FEMALE"
  ASBHCPLM = "GEN/COMPLETED BY/MALE"
  ASBHCPLO = "GEN/COMPLETED BY/OTHER"
  ASBHAC1  = "GEN/HOME ACTIVITIES/READ BOOKS"
  ASBHAC2  = "GEN/HOME ACTIVITIES/TELL STORIES"
  ASBHAC3  = "GEN/HOME ACTIVITIES/SING SONGS"
  ASBHAC4  = "GEN/HOME ACTIVITIES/PLAY WITH ABC-TOYS"
  ASBHAC5  = "GEN/HOME ACTIVITIES/READING ACTS ON PC"
  ASBHAC6  = "GEN/HOME ACTIVITIES/PLAY WORD GAMES"
  ASBHAC7  = "GEN/HOME ACTIVITIES/WRITE LETTERS,WORDS"
  ASBHAC8  = "GEN/HOME ACTIVITIES/RD SIGNS,LABELS"
  ASBHAC9  = "GEN/HOME ACTIVITIES/WATCH TV TCH RDG"
  ASBHAC10 = "GEN/HOME ACTIVITIES/<WATCH TV+SUBTITLES>"
  ASBHAC11 = "GEN/HOME ACTIVITIES/<COUNTRY-SPECIFIC>"
  ASBH0ATT = "GEN/CHD ATTEND LEVEL0"
  ASBH0TIM = "GEN/CHD ATTEND LEVEL0/LENGTH"
  ASBHAGE  = "GEN/CHD AGE LEVEL1"
  ASBHABI1 = "GEN/ABILITY LEVEL1/RECOGNIZE LETTERS"
  ASBHABI2 = "GEN/ABILITY LEVEL1/READ SOME WORDS"
  ASBHABI3 = "GEN/ABILITY LEVEL1/READ SENTENCES"
  ASBHABI4 = "GEN/ABILITY LEVEL1/WRITE LETTERS"
  ASBHABI5 = "GEN/ABILITY LEVEL1/WRITE SOME WORDS"
  ASBHTWC1 = "GEN/THINGS WITH CHD DONE/READ TO CHD"
  ASBHTWC2 = "GEN/THINGS WITH CHD DONE/LISTEN CHD READ"
  ASBHTWC3 = "GEN/THINGS WITH CHD DONE/TALK CHD RDG"
  ASBHTWC4 = "GEN/THINGS WITH CHD DONE/TALK CHD P-READ"
  ASBHTWC5 = "GEN/THINGS WITH CHD DONE/DISCUSS READING"
  ASBHTWC6 = "GEN/THINGS WITH CHD DONE/LIBRARY,BKSTORE"
  ASBHTWC7 = "GEN/THINGS WITH CHD DONE/PLAY,WORK ON PC"
  ASBHTWC8 = "GEN/THINGS WITH CHD DONE/ENCOURAGE WRITE"
  ASBHCON1 = "GEN/CONTACTS TO FAM/ASSIGNMENTS"
  ASBHCON2 = "GEN/CONTACTS TO FAM/EXAMPLES OF CLSWORK"
  ASBHCON3 = "GEN/CONTACTS TO FAM/INFO CHD PERFORMANCE"
  ASBHTHK1 = "GEN/THOUGHTS ABOUT SCH/INCLUDING PAR"
  ASBHTHK2 = "GEN/THOUGHTS ABOUT SCH/SCH CARES"
  ASBHTHK3 = "GEN/THOUGHTS ABOUT SCH/SCH HELPS"
  ASBHREAD = "GEN/SPEND READING AT HOME"
  ASBHRRE1 = "GEN/READING REASONS/FOR WORK"
  ASBHRRE2 = "GEN/READING REASONS/FOR ENJOYMENT"
  ASBHRRE3 = "GEN/READING REASONS/TO GET NEWS"
  ASBHRRE4 = "GEN/READING REASONS/FOR EDUCATION,SCH"
  ASBHRRE5 = "GEN/READING REASONS/OTHER REASONS"
  ASBHSTM1 = "GEN/STATEMENTS/READ IF HAVE TO"
  ASBHSTM2 = "GEN/STATEMENTS/TALKING ABOUT BOOKS"
  ASBHSTM3 = "GEN/STATEMENTS/SPARE TIME READING"
  ASBHSTM4 = "GEN/STATEMENTS/READING FOR INFORMATIONS"
  ASBHSTM5 = "GEN/STATEMENTS/RDG AS IMPORTANT ACTIVITY"
  ASBHBOOK = "GEN/HOW MANY BOOKS AT HOME"
  ASBHCHBK = "GEN/HOW MANY CHD BOOKS AT HOME"
  ASBHEDUF = "GEN/HIGHEST EDUCATION/FATHER"
  ASBHEDUM = "GEN/HIGHEST EDUCATION/MOTHER"
  ASBHEMPF = "GEN/EMPLOYMENT SITUATION/FATHER"
  ASBHEMPM = "GEN/EMPLOYMENT SITUATION/MOTHER"
  ASBHMJF  = "GEN/MAIN JOBS/FATHER"
  ASBHMJM  = "GEN/MAIN JOBS/MOTHER"
  ASBHWELL = "GEN/WELL-OFF FAMILY FINANCIALLY"
  ASBHINCM = "GEN/ANNUAL HOUSEHOLD INCOME"
  ASBHCOMP = "GEN/TIME TO COMPLETE QUESTIONNAIRE"
  DPCDATE  = "DATE OF CREATION AT DPC"
  ASDHHLA  = "INDEX OF EARLY HOME LITERACY ACTIVITIES"
  ASDHEDUP = "PARENTS HIGHEST EDUCATION LEVEL"
  ASDHPEMP = "PARENTS EMPLOYMENT SITUATION"
  ASDHPATR = "INDEX/PARENTS ATTITUDE TO READING (PATR)"
  ASDHABI  = "PARNTS ESTIM. CHILD.S EARLY LIT. SKILLS"
  ASDHCON  = "SCHOOL ASK PARNTS REVIEW LANGUAGE PROGRE"
;

%PUT INFO: recode "not administered" data to missing code ".A" ;
*NOTE: If a CHECK variable is coded correctly with a BLANK, it will be recoded
       to "1", otherwise it will be recoded to "0" ;

IF IDPOP    = 8                THEN IDPOP    = .A ;
IF IDGRADER = 8                THEN IDGRADER = .A ;
IF INPRL01  = 8                THEN INPRL01  = .A ;
IF ASBHCPLF = 8                THEN ASBHCPLF = .A ;
IF ASBHCPLM = 8                THEN ASBHCPLM = .A ;
IF ASBHCPLO = 8                THEN ASBHCPLO = .A ;
IF ASBHAC1  = 8                THEN ASBHAC1  = .A ;
IF ASBHAC2  = 8                THEN ASBHAC2  = .A ;
IF ASBHAC3  = 8                THEN ASBHAC3  = .A ;
IF ASBHAC4  = 8                THEN ASBHAC4  = .A ;
IF ASBHAC5  = 8                THEN ASBHAC5  = .A ;
IF ASBHAC6  = 8                THEN ASBHAC6  = .A ;
IF ASBHAC7  = 8                THEN ASBHAC7  = .A ;
IF ASBHAC8  = 8                THEN ASBHAC8  = .A ;
IF ASBHAC9  = 8                THEN ASBHAC9  = .A ;
IF ASBHAC10 = 8                THEN ASBHAC10 = .A ;
IF ASBHAC11 = 8                THEN ASBHAC11 = .A ;
IF ASBH0ATT = 8                THEN ASBH0ATT = .A ;
IF ASBH0TIM = 8                THEN ASBH0TIM = .A ;
IF ASBHAGE  = 8                THEN ASBHAGE  = .A ;
IF ASBHABI1 = 8                THEN ASBHABI1 = .A ;
IF ASBHABI2 = 8                THEN ASBHABI2 = .A ;
IF ASBHABI3 = 8                THEN ASBHABI3 = .A ;
IF ASBHABI4 = 8                THEN ASBHABI4 = .A ;
IF ASBHABI5 = 8                THEN ASBHABI5 = .A ;
IF ASBHTWC1 = 8                THEN ASBHTWC1 = .A ;
IF ASBHTWC2 = 8                THEN ASBHTWC2 = .A ;
IF ASBHTWC3 = 8                THEN ASBHTWC3 = .A ;
IF ASBHTWC4 = 8                THEN ASBHTWC4 = .A ;
IF ASBHTWC5 = 8                THEN ASBHTWC5 = .A ;
IF ASBHTWC6 = 8                THEN ASBHTWC6 = .A ;
IF ASBHTWC7 = 8                THEN ASBHTWC7 = .A ;
IF ASBHTWC8 = 8                THEN ASBHTWC8 = .A ;
IF ASBHCON1 = 8                THEN ASBHCON1 = .A ;
IF ASBHCON2 = 8                THEN ASBHCON2 = .A ;
IF ASBHCON3 = 8                THEN ASBHCON3 = .A ;
IF ASBHTHK1 = 8                THEN ASBHTHK1 = .A ;
IF ASBHTHK2 = 8                THEN ASBHTHK2 = .A ;
IF ASBHTHK3 = 8                THEN ASBHTHK3 = .A ;
IF ASBHREAD = 8                THEN ASBHREAD = .A ;
IF ASBHRRE1 = 8                THEN ASBHRRE1 = .A ;
IF ASBHRRE2 = 8                THEN ASBHRRE2 = .A ;
IF ASBHRRE3 = 8                THEN ASBHRRE3 = .A ;
IF ASBHRRE4 = 8                THEN ASBHRRE4 = .A ;
IF ASBHRRE5 = 8                THEN ASBHRRE5 = .A ;
IF ASBHSTM1 = 8                THEN ASBHSTM1 = .A ;
IF ASBHSTM2 = 8                THEN ASBHSTM2 = .A ;
IF ASBHSTM3 = 8                THEN ASBHSTM3 = .A ;
IF ASBHSTM4 = 8                THEN ASBHSTM4 = .A ;
IF ASBHSTM5 = 8                THEN ASBHSTM5 = .A ;
IF ASBHBOOK = 8                THEN ASBHBOOK = .A ;
IF ASBHCHBK = 8                THEN ASBHCHBK = .A ;
IF ASBHEDUF = 98               THEN ASBHEDUF = .A ;
IF ASBHEDUM = 98               THEN ASBHEDUM = .A ;
IF ASBHEMPF = 8                THEN ASBHEMPF = .A ;
IF ASBHEMPM = 8                THEN ASBHEMPM = .A ;
IF ASBHMJF  = 98               THEN ASBHMJF  = .A ;
IF ASBHMJM  = 98               THEN ASBHMJM  = .A ;
IF ASBHWELL = 8                THEN ASBHWELL = .A ;
IF ASBHINCM = 8                THEN ASBHINCM = .A ;
IF ASBHCOMP = 98               THEN ASBHCOMP = .A ;
IF ASDHHLA  = 8                THEN ASDHHLA  = .A ;
IF ASDHEDUP = 8                THEN ASDHEDUP = .A ;
IF ASDHPEMP = 8                THEN ASDHPEMP = .A ;
IF ASDHPATR = 8                THEN ASDHPATR = .A ;
IF ASDHABI  = 8                THEN ASDHABI  = .A ;
IF ASDHCON  = 8                THEN ASDHCON  = .A ;

%PUT INFO: recode special missing codes to SAS missing codes ;
*NOTE: Special missing codes are recoded to SAS
       character - missing codes;

IF ASBH0TIM = 6                THEN ASBH0TIM = .B ;

%PUT INFO: recode omitted data to missing code "." ;
*NOTE: BLANKS are recoded to SYSMIS by SAS ;

IF IDPOP    = 9                THEN IDPOP    = . ;
IF IDGRADER = 9                THEN IDGRADER = . ;
IF INPRL01  = 9                THEN INPRL01  = . ;
IF ASBHCPLF = 9                THEN ASBHCPLF = . ;
IF ASBHCPLM = 9                THEN ASBHCPLM = . ;
IF ASBHCPLO = 9                THEN ASBHCPLO = . ;
IF ASBHAC1  = 9                THEN ASBHAC1  = . ;
IF ASBHAC2  = 9                THEN ASBHAC2  = . ;
IF ASBHAC3  = 9                THEN ASBHAC3  = . ;
IF ASBHAC4  = 9                THEN ASBHAC4  = . ;
IF ASBHAC5  = 9                THEN ASBHAC5  = . ;
IF ASBHAC6  = 9                THEN ASBHAC6  = . ;
IF ASBHAC7  = 9                THEN ASBHAC7  = . ;
IF ASBHAC8  = 9                THEN ASBHAC8  = . ;
IF ASBHAC9  = 9                THEN ASBHAC9  = . ;
IF ASBHAC10 = 9                THEN ASBHAC10 = . ;
IF ASBHAC11 = 9                THEN ASBHAC11 = . ;
IF ASBH0ATT = 9                THEN ASBH0ATT = . ;
IF ASBH0TIM = 9                THEN ASBH0TIM = . ;
IF ASBHAGE  = 9                THEN ASBHAGE  = . ;
IF ASBHABI1 = 9                THEN ASBHABI1 = . ;
IF ASBHABI2 = 9                THEN ASBHABI2 = . ;
IF ASBHABI3 = 9                THEN ASBHABI3 = . ;
IF ASBHABI4 = 9                THEN ASBHABI4 = . ;
IF ASBHABI5 = 9                THEN ASBHABI5 = . ;
IF ASBHTWC1 = 9                THEN ASBHTWC1 = . ;
IF ASBHTWC2 = 9                THEN ASBHTWC2 = . ;
IF ASBHTWC3 = 9                THEN ASBHTWC3 = . ;
IF ASBHTWC4 = 9                THEN ASBHTWC4 = . ;
IF ASBHTWC5 = 9                THEN ASBHTWC5 = . ;
IF ASBHTWC6 = 9                THEN ASBHTWC6 = . ;
IF ASBHTWC7 = 9                THEN ASBHTWC7 = . ;
IF ASBHTWC8 = 9                THEN ASBHTWC8 = . ;
IF ASBHCON1 = 9                THEN ASBHCON1 = . ;
IF ASBHCON2 = 9                THEN ASBHCON2 = . ;
IF ASBHCON3 = 9                THEN ASBHCON3 = . ;
IF ASBHTHK1 = 9                THEN ASBHTHK1 = . ;
IF ASBHTHK2 = 9                THEN ASBHTHK2 = . ;
IF ASBHTHK3 = 9                THEN ASBHTHK3 = . ;
IF ASBHREAD = 9                THEN ASBHREAD = . ;
IF ASBHRRE1 = 9                THEN ASBHRRE1 = . ;
IF ASBHRRE2 = 9                THEN ASBHRRE2 = . ;
IF ASBHRRE3 = 9                THEN ASBHRRE3 = . ;
IF ASBHRRE4 = 9                THEN ASBHRRE4 = . ;
IF ASBHRRE5 = 9                THEN ASBHRRE5 = . ;
IF ASBHSTM1 = 9                THEN ASBHSTM1 = . ;
IF ASBHSTM2 = 9                THEN ASBHSTM2 = . ;
IF ASBHSTM3 = 9                THEN ASBHSTM3 = . ;
IF ASBHSTM4 = 9                THEN ASBHSTM4 = . ;
IF ASBHSTM5 = 9                THEN ASBHSTM5 = . ;
IF ASBHBOOK = 9                THEN ASBHBOOK = . ;
IF ASBHCHBK = 9                THEN ASBHCHBK = . ;
IF ASBHEDUF = 99               THEN ASBHEDUF = . ;
IF ASBHEDUM = 99               THEN ASBHEDUM = . ;
IF ASBHEMPF = 9                THEN ASBHEMPF = . ;
IF ASBHEMPM = 9                THEN ASBHEMPM = . ;
IF ASBHMJF  = 99               THEN ASBHMJF  = . ;
IF ASBHMJM  = 99               THEN ASBHMJM  = . ;
IF ASBHWELL = 9                THEN ASBHWELL = . ;
IF ASBHINCM = 9                THEN ASBHINCM = . ;
IF ASBHCOMP = 99               THEN ASBHCOMP = . ;
IF ASDHHLA  = 9                THEN ASDHHLA  = . ;
IF ASDHEDUP = 9                THEN ASDHEDUP = . ;
IF ASDHPEMP = 9                THEN ASDHPEMP = . ;
IF ASDHPATR = 9                THEN ASDHPATR = . ;
IF ASDHABI  = 9                THEN ASDHABI  = . ;
IF ASDHCON  = 9                THEN ASDHCON  = . ;

%PUT INFO: assign variable labels to recoded variables ;
LABEL
;

proc sort ; by idcntry idstud;

       %let i = %eval(&i + 1);
     %end;
run;
%mend doit;

%doit;










