SET DECIMAL = DOT.

define create (country=!charend('/')).

!let !datpath = !unquote("c:\pirls\Data\").
!let !savpath = !unquote("c:\pirls\Data\").

!do !cty !in(!country).

!let !indata  = !concat('"',!datpath,ast,!cty,'r1.dat"').
!let !savdata = !concat('"',!savpath,ast,!cty,'r1.sav"').

*NOTE: Assignment of variable names.

data list file = !indata
 /IDCNTRY     1-   5     
  IDSCHOOL    6-   9     
  IDCLASS    10-  15     
  IDSTUD     16-  23     
  IDPOP      24-  24     
  IDGRADER   25-  25     
  INPRL01    26-  26     
  JKZONE     27-  28     
  JKREP      29-  29     
  IDTEACH    30-  35     
  IDLINK     36-  37     
  NTEACH     38-  39     
  TCHWGT     40-  52 (6)
  DPCDATE    53-  58     
  ASRINF01   59-  71 (6)
  ASRINF02   72-  84 (6)
  ASRINF03   85-  97 (6)
  ASRINF04   98- 110 (6)
  ASRINF05  111- 123 (6)
  ASRLIT01  124- 136 (6)
  ASRLIT02  137- 149 (6)
  ASRLIT03  150- 162 (6)
  ASRLIT04  163- 175 (6)
  ASRLIT05  176- 188 (6)
  ASRREA01  189- 201 (6)
  ASRREA02  202- 214 (6)
  ASRREA03  215- 227 (6)
  ASRREA04  228- 240 (6)
  ASRREA05  241- 253 (6).


*NOTE: Assignment of variable labels.

variable labels   IDCNTRY  "*COUNTRY ID*" 
                 /IDSCHOOL "*SCHOOL ID*" 
                 /IDCLASS  "*CLASS ID*" 
                 /IDSTUD   "*STUDENT ID*" 
                 /IDPOP    "*POPULATION ID*" 
                 /IDGRADER "*GRADE*" 
                 /INPRL01  "*INPRL01*" 
                 /JKZONE   "*ZONE CODE*" 
                 /JKREP    "*REPLICATE CODE*" 
                 /IDTEACH  "*TEACHER ID*" 
                 /IDLINK   "*LINK ID*" 
                 /NTEACH   "*# OF READING TEACHERS COMBINED*" 
                 /TCHWGT   "*WEIGHT FOR RDG TEACHER DATA COMBINED*" 
                 /DPCDATE  "DATE OF CREATION AT DPC" 
                 /ASRINF01 "PLAUSIBLE VALUE: INFORMATION BLOCKS PV1" 
                 /ASRINF02 "PLAUSIBLE VALUE: INFORMATION BLOCKS PV2" 
                 /ASRINF03 "PLAUSIBLE VALUE: INFORMATION BLOCKS PV3" 
                 /ASRINF04 "PLAUSIBLE VALUE: INFORMATION BLOCKS PV4" 
                 /ASRINF05 "PLAUSIBLE VALUE: INFORMATION BLOCKS PV5" 
                 /ASRLIT01 "PLAUSIBLE VALUE: LITERARY BLOCKS PV1" 
                 /ASRLIT02 "PLAUSIBLE VALUE: LITERARY BLOCKS PV2" 
                 /ASRLIT03 "PLAUSIBLE VALUE: LITERARY BLOCKS PV3" 
                 /ASRLIT04 "PLAUSIBLE VALUE: LITERARY BLOCKS PV4" 
                 /ASRLIT05 "PLAUSIBLE VALUE: LITERARY BLOCKS PV5" 
                 /ASRREA01 "PLAUSIBLE VALUE: ALL BLOCKS PV1" 
                 /ASRREA02 "PLAUSIBLE VALUE: ALL BLOCKS PV2" 
                 /ASRREA03 "PLAUSIBLE VALUE: ALL BLOCKS PV3" 
                 /ASRREA04 "PLAUSIBLE VALUE: ALL BLOCKS PV4" 
                 /ASRREA05 "PLAUSIBLE VALUE: ALL BLOCKS PV5".


*NOTE: Assignment of value labels.

VALUE LABELS
            IDPOP      9  "OMITTED"
                       /
            IDGRADER   9  "OMITTED"
                       /
            INPRL01    9  "OMITTED"
                       /
.


*NOTE: The "Not administered code" will be recoded to "sysmis"
       Variables coded BLANK are coded to "sysmis" as well
       If a CHECK variable is coded correctly with a BLANK, it will be recoded
       to "1", otherwise it will be recoded to "0".

recode IDCNTRY  (99998            = sysmis).
recode IDSCHOOL (9998             = sysmis).
recode IDCLASS  (999998           = sysmis).
recode IDSTUD   (99999998         = sysmis).
recode IDPOP    (8                = sysmis).
recode IDGRADER (8                = sysmis).
recode INPRL01  (8                = sysmis).
recode JKZONE   (98               = sysmis).
recode JKREP    (8                = sysmis).
recode IDTEACH  (999998           = sysmis).
recode IDLINK   (98               = sysmis).
recode NTEACH   (98               = sysmis).
recode TCHWGT   (999998           = sysmis).
recode ASRINF01 (999998           = sysmis).
recode ASRINF02 (999998           = sysmis).
recode ASRINF03 (999998           = sysmis).
recode ASRINF04 (999998           = sysmis).
recode ASRINF05 (999998           = sysmis).
recode ASRLIT01 (999998           = sysmis).
recode ASRLIT02 (999998           = sysmis).
recode ASRLIT03 (999998           = sysmis).
recode ASRLIT04 (999998           = sysmis).
recode ASRLIT05 (999998           = sysmis).
recode ASRREA01 (999998           = sysmis).
recode ASRREA02 (999998           = sysmis).
recode ASRREA03 (999998           = sysmis).
recode ASRREA04 (999998           = sysmis).
recode ASRREA05 (999998           = sysmis).


*NOTE: recode "omitted" data to user defined "missing value"

missing value IDCNTRY (99999).
missing value IDSCHOOL(9999).
missing value IDCLASS (999999).
missing value IDSTUD  (99999999).
missing value IDPOP   (9).
missing value IDGRADER(9).
missing value INPRL01 (9).
missing value JKZONE  (99).
missing value JKREP   (9).
missing value IDTEACH (999999).
missing value IDLINK  (99).
missing value NTEACH  (99).
missing value TCHWGT  (999999).
missing value ASRINF01(999999).
missing value ASRINF02(999999).
missing value ASRINF03(999999).
missing value ASRINF04(999999).
missing value ASRINF05(999999).
missing value ASRLIT01(999999).
missing value ASRLIT02(999999).
missing value ASRLIT03(999999).
missing value ASRLIT04(999999).
missing value ASRLIT05(999999).
missing value ASRREA01(999999).
missing value ASRREA02(999999).
missing value ASRREA03(999999).
missing value ASRREA04(999999).
missing value ASRREA05(999999).


*NOTE: These statements format the variable
       according to the length and decimal places.

format IDCNTRY  (f5.0).
format IDSCHOOL (f4.0).
format IDCLASS  (f6.0).
format IDSTUD   (f8.0).
format IDPOP    (f1.0).
format IDGRADER (f1.0).
format INPRL01  (f1.0).
format JKZONE   (f2.0).
format JKREP    (f1.0).
format IDTEACH  (f6.0).
format IDLINK   (f2.0).
format NTEACH   (f2.0).
format TCHWGT   (f13.6).
format DPCDATE  (f6.0).
format ASRINF01 (f13.6).
format ASRINF02 (f13.6).
format ASRINF03 (f13.6).
format ASRINF04 (f13.6).
format ASRINF05 (f13.6).
format ASRLIT01 (f13.6).
format ASRLIT02 (f13.6).
format ASRLIT03 (f13.6).
format ASRLIT04 (f13.6).
format ASRLIT05 (f13.6).
format ASRREA01 (f13.6).
format ASRREA02 (f13.6).
format ASRREA03 (f13.6).
format ASRREA04 (f13.6).
format ASRREA05 (f13.6).


*NOTE: save statement uses compressed option
       If you do not want copressed files,
       delete the /COMPRESSED statement.

sort cases by idcntry idteach idlink.

save outfile = !savdata.

!doend
!enddefine

create country = ARG BGR BLZ CAN COL CYP CZE DEU ENG FRA
                 GRC HKG HUN IRN ISL ISR ITA KWT LTU LVA
                 MAR MDA MKD NLD NOR NZL ROM RUS SCO SGP
                 SVK SVN SWE TUR USA SE3.

