title "Example 5: PIRLS 2001 User Guide".

add files
 / file = "c:\pirls\data\asgargr1.sav"
 / file = "c:\pirls\data\asgbgrr1.sav"
 / file = "c:\pirls\data\asgswer1.sav"
 / file = "c:\pirls\data\asgturr1.sav" .

sort cases by idcntry idstud.

save outfile = student
  / keep = idcntry idschool idstud asrrea01 to asrrea05 inprl01 totwgt jkzone jkrep.

add files
 / file = "c:\pirls\data\ashargr1.sav"
 / file = "c:\pirls\data\ashbgrr1.sav"
 / file = "c:\pirls\data\ashswer1.sav"
 / file = "c:\pirls\data\ashturr1.sav" .

sort cases by idcntry idstud.

save outfile = home
  / keep = idcntry idstud asdhpatr.

* Now merge the two files.
match files
  / file = student
  / file = home
  / by idcntry idstud.

select if not(missing(asdhpatr)) and inprl01=1.

* Define the format for the variables used.
value labels 
 idcntry  32 'Argentina' 100 'Bulgaria' 752 'Sweden' 792 'Turkey' 840 'United States' /
 asdhpatr  1 'High'  2 'Medium' 3 'Low'.

save outfile = merged.

* Now use the macro to get the results.
include "c:\pirls\programs\jackpv.sps".

jackpv infile= merged            /
       cvar  = idcntry asdhpatr  /
       pvs   = asrrea01 to asrrea05 /
       npv   = 5        /
       jkz   = JKZONE   /
       jkr   = JKREP    /
       njkz  = 75       /
       WGT   = TOTWGT   .

sort cases by idcntry.

print formats n (f6.0) totwgt (f10.0) mnpv mnpv_se pct pct_se (f6.2).

report format=list automatic
  / var   = asdhpatr (label) n totwgt mnpv mnpv_se pct pct_se
  / break = idcntry .
